(function( $ ) {
	'use strict';
	$(document).ready(function () {

		$(document).find('[data-bs-toggle="tooltip"]').tooltip();

		$(document).find('#ays-category').select2({
			placeholder: 'Select category'
		});

		$(document).find('#ays-status').select2({
			placeholder: 'Select status'
		});

		//
		$(document).find('.nav-tab-wrapper a.nav-tab').on('click', function (e) {
		    if(! $(this).hasClass('no-js')){
		        var elemenetID = $(this).attr('href');
		        var active_tab = $(this).attr('data-tab');
		        $(document).find('.nav-tab-wrapper a.nav-tab').each(function () {
		            if ($(this).hasClass('nav-tab-active')) {
		                $(this).removeClass('nav-tab-active');
		            }
		        });
		        $(this).addClass('nav-tab-active');
		        $(document).find('.ays-tab-content').each(function () {
		            $(this).css('display', 'none');
		        });
		        $(document).find("[name='ays_tab']").val(active_tab);
		        $('.ays-tab-content' + elemenetID).css('display', 'block');
		        e.preventDefault();
		    }
		});

		$(document).on('keydown', function(e){
			var saveButton = $(document).find('input.ays-chatgpt-assistant-general-settings-save');
			if ( saveButton.length > 0 ) {
                if (!(e.which == 83 && e.ctrlKey) && !(e.which == 19)){
                    return true;
                }
                saveButton.trigger("click");
                e.preventDefault();
                return false;
            }
		});

		$(document).find('#ays_user_roles').select2({
			allowClear: true,
			placeholder: aysChatGptAssistantAdminSettings.selectUserRoles
		});

		// Submit buttons disableing with loader
		$(document).find('.ays-chatgpt-assistant-loader-banner').on('click', function () {        
			var $this = $(this);
			submitOnce($this);
		});

		function submitOnce(subButton){
			var subLoader = subButton.parents('div').find('.ays_chatgpt_assistant_loader_box');
			if ( subLoader.hasClass("display_none") ) {
				subLoader.removeClass("display_none");
			}
			subLoader.css({
				"padding-left": "8px",
				"display": "inline-block"
			});

			setTimeout(function() {
				$(document).find('.ays-chatgpt-assistant-loader-banner').attr('disabled', true);
			}, 10);

			setTimeout(function() {
				$(document).find('.ays-chatgpt-assistant-loader-banner').attr('disabled', false);
				subButton.parents('div').find('.ays_chatgpt_assistant_loader_box').css('display', 'none');
			}, 5000);

		}

		$(document).find('#ays-chatgpt-assistant-chatbox-mode').on('click', function () {
			var responseColor = $(document).find('#ays-chatgpt-assistant-response-color');
			var messageColor = $(document).find('#ays-chatgpt-assistant-message-color');
			if ($(this).is(":checked")) {
				responseColor.val("#4b4d56");
				messageColor.val("#343541");
			} else {
				responseColor.val("#d3d3d3");
				messageColor.val("#4e426d");
			}
		});

		$(document).find('#ays-chatgpt-assistant-chatbox-mode').on('click', function () {
			var bGColor = $(document).find('#ays-chatgpt-assistant-chatbox-background-color');
			if ($(this).is(":checked")) {
				bGColor.val("#343541");
			} else {
				bGColor.val("#ffffff");
			}
		})

		$(document).find('.ays-chatgpt-assistant-chat-setting-range').on('input', function () {
			var thisParent = $(this).parent();
			thisParent.find('.ays-chatgpt-assistant-chat-limit-text').text($(this).val())
		});

	});

})( jQuery );
