<?php
$loader_iamge = "<span class='display_none ays_chatgpt_assistant_loader_box ays_chatgpt_assistant_loader_box_connection'><img src=". CHATGPT_ASSISTANT_ADMIN_URL ."/images/loaders/loading.gif></span>";
$data = $this->db_obj->get_data();

$id = isset( $data['id'] ) && $data['id'] > 0 ? intval( $data['id'] ) : 0;

$api_key = isset( $data['api_key'] ) && $data['api_key'] != '' ? esc_attr( $data['api_key'] ) : '';

$options = isset( $data['options'] ) && $data['options'] != '' ? json_decode(esc_attr( $data['options'] ) ): '';

$check_openai_connection = ChatGPT_assistant_Data::makeRequest($api_key, 'GET', 'models');
$check_openai_connection_code = false;

if(is_array($check_openai_connection)){
    $check_openai_connection_code = isset($check_openai_connection['openai_response_code']) && $check_openai_connection['openai_response_code'] == 200 ? true : false; 
}


$connection_text =  __('Disconnected' , "ays-chatgpt-assistant") . '!';
$connection_button_text =  __('Connect' , "ays-chatgpt-assistant");
$connection_button_class = 'connect';

if($check_openai_connection_code){
    $connection_text = __('Connected' , "ays-chatgpt-assistant") . '!';
    $connection_button_text = __('Disconnect' , "ays-chatgpt-assistant");
    $connection_button_class = 'disconnect';
}
?>
<div class="wrap">
    <h1 class="wp-heading-inline">
        <?php
            echo __( esc_html( get_admin_page_title() ), "ays-chatgpt-assistant" );
        ?>
    </h1>
    <hr/>
    <div id="poststuff">
        <div id="post-body" class="metabox-holder">
            <div id="post-body-content">
                <div class="meta-box-sortables ui-sortable">
                    <form method="post">
                        <input type="hidden" name="ays_chatgpt_assistant_id" value="<?php echo esc_attr($id); ?>" id="<?php echo esc_attr(CHATGPT_ASSISTANT_ID_PREFIX); ?>-main-id">
                        <div>
                            <h3><?php echo __('To get an API key for the OpenAI API, follow these steps:', "ays-chatgpt-assistant"); ?></h3>
                            <ol>
                                <li><?php echo sprintf(__('Sign up %shere%s. You can use your Google or Microsoft account to sign up if you don`t want to create using an email/password combination. You may need a valid mobile number to verify your account.', "ays-chatgpt-assistant"), '<a href="https://beta.openai.com/signup" target="_blank">', '</a>'); ?></li>
                                <li><?php echo sprintf(__('Now, visit your %sOpenAI key page%s.', "ays-chatgpt-assistant"), '<a href="https://beta.openai.com/account/api-keys" target="_blank">', '</a>'); ?></li>
                                <li><?php echo __('Create a new key by clicking the "Create new secret key" button.', "ays-chatgpt-assistant"); ?></li>
                                <li><?php echo __('Copy the key and paste it here', "ays-chatgpt-assistant"); ?></li>
                                <li><?php echo __('Click "Connect" button.', "ays-chatgpt-assistant"); ?></li>
                            </ol>
                            <p><strong><?php echo __('Note: Access to the OpenAI API is currently limited, so you may need to wait for approval before you can start using the API.', "ays-chatgpt-assistant"); ?></strong></p>
                        </div>
                        <div class="<?php echo esc_attr(CHATGPT_ASSISTANT_CLASS_PREFIX); ?>-make-connection">
                             
                            <div class="<?php echo esc_attr(CHATGPT_ASSISTANT_CLASS_PREFIX); ?>-connection">                            
                                <input type="text" class="<?php echo esc_attr(CHATGPT_ASSISTANT_CLASS_PREFIX); ?>-api-key-box" name="ays_chatgpt_assistant_api_key" value="<?php echo esc_attr($api_key); ?>">
                                <button type="button" class="<?php echo esc_attr(CHATGPT_ASSISTANT_CLASS_PREFIX); ?>-<?php echo $connection_button_class; ?>-button" name="ays_chatgpt_assistant_save_bttn"><?php echo $connection_button_text; ?></button>
                                <?php echo $loader_iamge; ?>
                            </div>
                            <div style="margin-top: 5px;">
                                <span class="<?php echo esc_attr(CHATGPT_ASSISTANT_CLASS_PREFIX)."-api-key-connection-message "; echo $check_openai_connection_code ? CHATGPT_ASSISTANT_CLASS_PREFIX."-api-key-connection-success-message" : ""; ?>"><?php echo $connection_text;?></span>                                
                            </div> 
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>