<?php
    require_once 'chatgpt-assistant-front-chat-actions-options.php';
?>
<div class="wrap">
    <div class="container-fluid">
        <form method="post" id="ays-chat-form">
            <h1 class="wp-heading-inline">
            <?php
                echo __('Settings',$this->plugin_name);
            ?>
            </h1>
            <hr/>
            <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-settings-wrapper">
                <!-- Display chat on pages start -->
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label>
                            <span><?php echo __('Display', $this->plugin_name); ?></span>
                            <a class="ays_help" data-bs-toggle="tooltip"
                               title="<?php echo __('Define the pages your popup will be loaded on.', $this->plugin_name); ?>">
                                <i class="ays_fa ays_fa-info-circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8 ays_divider_left">
                        <label class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-label-style <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-display-type-select" for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-all-pages"><?php echo __("All pages", $this->plugin_name); ?>
                            <input type="radio" id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-all-pages" name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[display_chat_on_page]" value="all" <?php echo ($chatgpt_assistant_display_chat_on_page == 'all') ? 'checked' : ''; ?> />
                        </label>
                        <label class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-label-style <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-display-type-select" for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-except-pages"><?php echo __("Except", $this->plugin_name); ?>
                            <input type="radio" id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-except-pages"   name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[display_chat_on_page]" value="except" <?php echo ($chatgpt_assistant_display_chat_on_page == 'except') ? 'checked' : ''; ?>/>
                        </label>
                        <label class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-label-style <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-display-type-select" for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-selected-pages"><?php echo __("Include", $this->plugin_name); ?>
                            <input type="radio" id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-display-chat-on-selected-pages"  name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[display_chat_on_page]" value="selected" <?php echo ($chatgpt_assistant_display_chat_on_page == 'selected') ? 'checked' : ''; ?>/>
                        </label>
                        <a class="ays_help" data-bs-toggle="tooltip" style="font-size:15px;" data-html="true"
                            title="<?php
                                echo __('Choose the method of calculation.',$this->plugin_name) .
                                "<ul style='list-style-type: circle;padding-left: 20px;'>".
                                    "<li>". __('All pages - The popup will display on all pages.',$this->plugin_name) ."</li>".
                                    "<li>". __('Except - Choose the post/page and post/page types excluding the popup.',$this->plugin_name) ."</li>".
                                    "<li>". __('Include - Choose the post/page and post/page types including the popup.',$this->plugin_name) ."</li>".
                                "</ul>";
                            ?>">
                            <i class="ays_fa ays_fa-info-circle"></i>
                        </a>
                    </div>
                </div>
                <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-view-place <?php echo ($chatgpt_assistant_display_chat_on_page != 'all') ? '' : 'display_none'; ?>" style="transition: 1s;">
                    <hr/>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="ays_pb_post_types"><?php echo __("Post type", $this->plugin_name); ?></label>
                            <a class="ays_help" data-bs-toggle="tooltip"
                               title="<?php echo __('Select post types.', $this->plugin_name) ?>">
                                <i class="ays_fa ays_fa-info-circle"></i>
                            </a>
                        </div>
                        <div class="col-sm-8 ays_divider_left">
                            <select name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[except_post_types][]"  id="ays_pb_post_types" class="form-control"
                                    multiple="multiple">
                                <?php
                                    foreach ($all_post_types as $post_type) {
                                        if($except_post_types) {
                                            $checked = (in_array($post_type->name, $except_post_types)) ? "selected" : "";
                                        }else{
                                            $checked = "";
                                        }
                                        echo "<option value='{$post_type->name}' {$checked}>{$post_type->label}</option>";
                                    }
                                ?>
                            </select>
                        </div>
                    </div>
                    <hr>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="ays_pb_posts"><?php echo __("Posts", $this->plugin_name); ?></label>
                            <a class="ays_help" data-bs-toggle="tooltip"
                               title="<?php echo __('Select posts.', $this->plugin_name) ?>">
                                <i class="ays_fa ays_fa-info-circle"></i>
                            </a>
                        </div>
                        <div class="col-sm-8 ays_divider_left">
                            <select name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[except_posts][]" id="ays_pb_posts" class="form-control"
                                    multiple="multiple">
                                <?php
                                    foreach ( $posts as $post ) {
                                       
                                        $checked = (is_array($except_posts) && in_array($post->ID, $except_posts)) ? "selected" : "";
                                        echo "<option value='{$post->ID}' {$checked}>{$post->post_title}</option>";
                                    }

                                    if (!empty($view_place)) {
                                        $args = array(
                                            'post_type' => array('post', 'page'),
                                            'nopaging'  => true
                                        );
                                        // Custom query.
                                        $query = new WP_Query( $args );

                                        if($query->have_posts()){
                                            foreach ($query->posts as $key => $post){
                                                if(in_array($post->ID, $view_place)):
                                                    ?>
                                                    <option selected value="<?php echo $post->ID; ?>"><?php echo __(get_the_title($post->ID), $this->plugin_name); ?></option> 
                                                <?php
                                                endif;
                                            }
                                        }
                                    }
                                ?>
                            </select>
                            <input type='hidden' id="ays_pb_except_posts_id">
                        </div>
                    </div>
                    <hr/>
                    <div class="form-group row">
                        <div class="col-sm-4">
                            <label for="ays_pb_show_on_home_page">
                                <span><?php echo __('Show on Home page', $this->plugin_name); ?></span>
                                <a class="ays_help" data-bs-toggle="tooltip" title="<?php echo __('If the checkbox is ticked, then the popup will be loaded on the Home page too, in addition to the values given above.', $this->plugin_name); ?>">
                                    <i class="ays_fa ays_fa-info-circle"></i>
                                </a>
                            </label>
                        </div>
                        <div class="col-sm-8 ays_divider_left">
                            <p class="onoffswitch">
                                <input type="checkbox" name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[show_on_home_page]" class="ays-pb-ays-pb-onoffswitch-checkbox" id="ays_pb_show_on_home_page" <?php echo ($chatgpt_assistant_show_on_home_page) ? 'checked' : '' ?> >
                            </p>
                        </div>
                    </div>
                </div>                
                <!-- Display chat on pages start -->
                <hr/>
                <!-- Logged in/guests access start -->
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-access-for-guests">
                            <?php echo __( "Allow access for guests", $this->plugin_name ); ?>
                            <!-- <a class="ays_help" data-bs-toggle="tooltip" title="<?php // echo __("....",$this->plugin_name)?>">
                                <img src="<?php // echo CHATGPT_ASSISTANT_ADMIN_URL; ?>/images/icons/info-circle.svg">
                            </a> -->
                        </label>
                    </div>
                    <div class="col-sm-8 ays_divider_left">
                        <label class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-switch">
                            <input class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch" type="checkbox" name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[access_for_guests]" id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-access-for-guests" value="on" <?php echo $chatgpt_assistant_access_for_guests; ?> >
                            <span class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-slider <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-round"></span>
                        </label>
                    </div>
                </div>
                <hr/>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-access-for-logged-in">
                            <?php echo __( "Allow access for logged in users", $this->plugin_name ); ?>
                            <!-- <a class="ays_help" data-bs-toggle="tooltip" title="<?php // echo __("....",$this->plugin_name)?>">
                                <img src="<?php // echo CHATGPT_ASSISTANT_ADMIN_URL; ?>/images/icons/info-circle.svg">
                            </a> -->
                        </label>
                    </div>
                    <div class="col-sm-1 ays_divider_left">
                        <label class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-switch">
                            <input class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch" type="checkbox" name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[access_for_logged_in]" id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-access-for-logged-in" value="on" <?php echo $chatgpt_assistant_access_for_logged_in; ?> >
                            <span class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-slider <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-toggle-switch-round"></span>
                        </label>
                    </div>
                    <div class="col-sm-7 ays_divider_left <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-logged-in-suboption <?php echo ($chatgpt_assistant_access_for_logged_in === 'checked') ? '' : 'display_none'; ?>" style="transition: 1s;">
                        <!-- User role permission start -->
                        <div class="form-group row">
                            <div class="row mb-3">
                                <label for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-user-roles">
                                    <?php echo __( "Allow access for user roles", $this->plugin_name ); ?>
                                    <!-- <a class="ays_help" data-bs-toggle="tooltip" title="<?php // echo __("....",$this->plugin_name)?>">
                                        <img src="<?php // echo CHATGPT_ASSISTANT_ADMIN_URL; ?>/images/icons/info-circle.svg">
                                    </a> -->
                                </label>
                            </div>
                            <div class="row">
                                <select name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[user_roles][]"  id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-user-roles" class="form-control" multiple="multiple">
                                    <?php
                                        foreach($ays_users_roles as $role => $role_name){
                                            $selected = in_array($role, $chatgpt_assistant_user_roles) ? 'selected' : '';
                                            echo "<option ".$selected." value='".$role."'>".$role_name."</option>";
                                        }
                                    ?>
                                </select>
                            </div>
                        </div>
                        <!-- User role permission start -->
                    </div>
                </div>
                <hr/>
                <!-- Logged in/guests access start -->

                <!-- Change chat icon start -->
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-chat-icon">
                            <?php echo __( "Change chat icon", $this->plugin_name ); ?>
                        </label>
                    </div>
                    <div class="col-sm-8 <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-image-container ays_divider_left">
                        <button id="<?php echo CHATGPT_ASSISTANT_ID_PREFIX; ?>-chat-icon" class="button <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-add-chat-icon" type="button"><?php echo $chatgpt_assistant_chat_icon_text; ?></button>
                        <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-image-body" style="<?php echo $chatgpt_assistant_chat_icon != '' ? '' : 'display: none;'; ?>">
                            <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-image-wrapper">
                                <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-image-wrapper-delete-wrap">
                                    <div role="button" class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-image-wrapper-delete-cont <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-logo-remove <?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>remove-image">
                                        <div class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-icons">
                                            <img src="<?php echo CHATGPT_ASSISTANT_ADMIN_URL; ?>/images/icons/close-grey.svg">
                                        </div>
                                    </div>
                                </div>
                                <img class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-img" src="<?php echo $chatgpt_assistant_chat_icon; ?>" />
                                <input type="hidden" name="<?php echo CHATGPT_ASSISTANT_NAME_PREFIX; ?>_settings[chat_icon]" class="<?php echo CHATGPT_ASSISTANT_CLASS_PREFIX; ?>-img-src" value="<?php echo $chatgpt_assistant_chat_icon; ?>"/>
                            </div>
                        </div>
                    </div>
                </div>
                <!-- Change chat icon start -->
            </div>
            <hr/>
            <div style="position:sticky;padding:15px 0px;bottom:0;">
            <?php
                wp_nonce_field('front_chat_action', 'front_chat_action');
                $other_attributes = array();
                submit_button(__('Save changes', $this->plugin_name), 'primary ays-chatgpt-assistant-loader-banner ays-chatgpt-assistant-general-settings-save', 'ays_submit', true, $other_attributes);
                // echo $loader_iamge;
            ?>
            </div>
        </form>
    </div>
</div>