<?php

if( ! class_exists( 'ChatGPT_Assistant_Dashboard_Chat_DB_Actions' ) ){
	ob_start();

	/**
	 * Class ChatGPT_Assistant_Settings_DB_Actions
	 * Class contains functions to interact with settings database
	 *
	 * Main functionality belong to inserting, updating and deleting
	 *
	 * Hooks used in the class
	 * @hooks           @filters        ays_chatgpt_assistant_item_save_settings
	 *
	 * Database tables without prefixes
	 * @tables          settings
	 *
	 * @param           $plugin_name
	 *
	 * @since           1.0.0
	 * @package         Ays_Chatgpt_Assistant
 	 * @subpackage      Ays_Chatgpt_Assistant/includes
 	 * @author          Ays_ChatGPT Assistant Team <info@ays-pro.com>
	 */
    class ChatGPT_Assistant_Dashboard_Chat_DB_Actions{	    
	    
        // public function __construct() {

	    //     global $wpdb;

	    //     /**
	    //      * Assigning $plugin_name to the @plugin_name property
	    //      */
	    //     // $this->plugin_name = $plugin_name;

	    //     /**
	    //      * Assigning database @charts table full name to the @db_table property
	    //      */
	    //     $this->db_table = $wpdb->prefix . CHATGPT_ASSISTANT_DB_PREFIX . "settings";

        // }

		public function store_data(){

			if( isset( $_REQUEST["settings_action"] ) && wp_verify_nonce( $_REQUEST["settings_action"], 'settings_action' ) ){
				$success = 0;
				$name_prefix = 'ays_';

				$user_roles = (isset($_REQUEST['ays_user_roles']) && !empty($_REQUEST['ays_user_roles'])) ? array_map( 'sanitize_text_field', $_REQUEST['ays_user_roles'] ) : array('administrator');               

				$chatbox_color = (isset($_REQUEST['ays_chatgpt_assistant_chatbox_color']) && $_REQUEST['ays_chatgpt_assistant_chatbox_color'] != '') ? sanitize_text_field($_REQUEST['ays_chatgpt_assistant_chatbox_color']) : '#4e426d' ;
				$chatbox_mode = (isset($_REQUEST['ays_chatgpt_assistant_chatbox_mode']) && $_REQUEST['ays_chatgpt_assistant_chatbox_mode'] != '') ? sanitize_text_field($_REQUEST['ays_chatgpt_assistant_chatbox_mode']) : 'light';
				$chatbox_onoff = (isset($_REQUEST['ays_chatgpt_assistant_chatbox_onoff']) && $_REQUEST['ays_chatgpt_assistant_chatbox_onoff'] != '') ? sanitize_text_field($_REQUEST['ays_chatgpt_assistant_chatbox_onoff']) : 'off';

				$options = array(
					'chatbox_color' => $chatbox_color,
					'chatbox_mode' => $chatbox_mode,

					'chatbox_onoff' => $chatbox_onoff

				);

				$fields = array();

				$fields['options'] = $options;

				foreach ($fields as $key => $value) {
					$result = $this->update_setting( $key, json_encode( $value ) );
					if($result){
						$success++;
					}
				}

				$message = "saved";
				if($success > 0){
					$tab = "";
					if( isset( $_REQUEST['ays_tab'] ) ){
						$tab = "&ays_tab=". sanitize_text_field( $_REQUEST['ays_tab'] );
					}

					$url = admin_url('admin.php') . "?page=". $this->plugin_name ."-settings" . $tab . '&status=' . $message;
					wp_redirect( $url );
					exit();
				}
			}

		}

        
	    
    }
}
