(function( $ ) {
	'use strict';

	$(document).on('click', '.ays-quiz-category-selective-submit-bttn', function(e){
        var _this = $(this);
		e.preventDefault();

		var form = $(document).find('.ays-quiz-category-selective-category-form');
		var formData = form.serializeFormJSON();
		var empty = false;

		for (var key in formData) {
			if (formData.hasOwnProperty.call(formData, key)) {
				var el = formData[key];
				if (!(el <= 0 || el == "")) {
					empty = true;
				}
				delete formData[key];
				key = key.match(/\d+/)[0];
				formData[key] = el;
			}
		}

        var quiz_id = _this.attr('data-quiz-id');
        var action = "ays_quiz_cat_set_cookie_data";

		if (empty) {
			$.ajax({
				url: quiz_maker_category_selective_ajax_public.ajax_url,
				method: 'post',
				dataType: 'json',
				data: {
					quiz_id: quiz_id,
					formData: formData,
					action: action
				},
				success: function(response){
					if (response.status === true) {
						window.location.reload();
					} else {
						alert("Something went wrong.");
					}
				},
				error: function(e){
					alert("Something went wrong.");
				}
			});
		} else {
			alert("You need to have at least one selected question.");
		}

    });

	$(document).on('click', '.ays-quiz-category-selective-restart-bttn', function(e){
        var _this = $(this);
		e.preventDefault();

        var quiz_id = _this.attr('data-quiz-id');
        var action = "ays_quiz_cat_delete_cookie_data";

		$.ajax({
			url: quiz_maker_category_selective_ajax_public.ajax_url,
			method: 'post',
			dataType: 'json',
			data: {
				quiz_id: quiz_id,
				action: action
			},
			success: function(response){
				if (response.status === true) {
					window.location.reload();
				} else {
					alert("Something went wrong.");
				}
			},
			error: function(e){
				alert("Something went wrong.");
			}
		});

    });

})( jQuery );
