(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	$(document).ready(function () {

	    var chainedQuizzesContainer = $(document).find('.ays_quiz_chained_quiz_box');

        var chainedQuizzesContainerLength = chainedQuizzesContainer.length;

        if(chainedQuizzesContainerLength == 1){
            chainedQuizzesContainer.find('.ays-delete-chained-quiz').addClass('display_none');
        }

        $(document).find('.ays_quiz_chained_quiz_box').find('.ays-chained-quizzes-select').select2({
                allowClear: false,
                placeholder: 'Select products'
            
        });

        $(document).on('click','.ays-delete-chained-quiz',function(){
            var chainedQuizzesContainer = $(document).find('.ays_quiz_chained_quiz_box');

            var chainedQuizzesContainerLength = chainedQuizzesContainer.length-1;

            $(this).parents('.ays_quiz_chained_quiz_box').remove();

            if(chainedQuizzesContainerLength == 1){
               chainedQuizzesContainer.find('.ays-delete-chained-quiz').addClass('display_none');
            }
        });


        $(document).find('.ays-add-chained-quiz-select').on('click', function () {
            var addedBox = $(document).find(".ays_quiz_chained_quiz_box");
            var addedBoxId = $(document).find(".ays_quiz_chained_quiz_box:last-child");
            var dataId = addedBox.length >= 1 ? parseInt(addedBoxId.attr("data-boxId")) + 1 : 1; 

            var removeIcon = $(document).find('.ays_quiz_chained_quiz_box').first().find('.ays-delete-chained-quiz');
            if(removeIcon.hasClass('display_none')){
                removeIcon.removeClass('display_none');
            }

            $(document).find('.ays_quiz_chained_quiz_box').first().find('.ays-chained-quizzes-select').select2("destroy");
            var quizBox = $(document).find('.ays_quiz_chained_quiz_box').first().clone();

            quizBox.find('.ays-chained-quizzes-select').val(0);
            quizBox.attr('data-boxid',dataId);

            $(document).find(".ays_quiz_chained_quiz_container").append(quizBox);

            $(document).find('.ays_quiz_chained_quiz_box').find('.ays-chained-quizzes-select').select2({
                allowClear: false,
                placeholder: 'Select products'
            });            
        });    

        $(document).find('.ays_quiz_chained_quiz_container').sortable({
            handle: 'div.ays_quiz_chained_quiz_box_sortable_arrow',
            cursor: 'move',
			opacity: 0.8,
            axis: 'y',
			placeholder: 'clone',
            tolerance: "pointer",
            helper: "clone",
            // revert: true,
            forcePlaceholderSize: true,
            forceHelperSize: true,
            update: function (event, ui) {
                var className = ui.item.attr('class').split(' ')[0];
                var sorting_ids = [];
                $(document).find('div.' + className).each(function (index) {
                    sorting_ids.push($(this).attr('data-boxid'));
                });

                sorting_ids.sort((a,b) => a - b);

                $(document).find('div.' + className).each(function (index) {
                    $(this).attr('data-boxid', sorting_ids[index]);
                });
            }
        })
	});
  

})( jQuery );
