<?php
global $wpdb;
$action = (isset($_GET['action'])) ? sanitize_text_field( $_GET['action'] ) : '';
$heading = '';
$id = ( isset( $_GET['chained_quiz'] ) ) ? absint( intval( $_GET['chained_quiz'] ) ) : null;

$options = array(
   'chained_quizzes_print_report' => 'off',
   'chained_quizzes_guest_access' => 'off',
   'calculate_report_type' => 'take_quiz',
);

$chained_quiz = array(
    'id'            => '',
    'title'         => '',
    'quiz_ids'      => '',
    'published'     => '',
    'options'       => json_encode( $options ),
);

switch( $action ) {
    case 'add':
        $heading = __('Add new chained quiz', $this->plugin_name);
        break;
    case 'edit':
        $heading = __('Edit chained quiz', $this->plugin_name);
        $chained_quiz = $this->chained_quizzes_obj->get_chained_quiz_by_id( $id );
        break;
}
if( isset( $_POST['ays_submit'] ) ) {
    $_POST['id'] = $id;
    $result = $this->chained_quizzes_obj->add_edit_chained_quiz( $_POST );
}
if(isset($_POST['ays_apply'])){
    $_POST["id"] = $id;
    $_POST['ays_change_type'] = 'apply';
    $this->chained_quizzes_obj->add_edit_chained_quiz($_POST);
}

// Options
$options = isset( $chained_quiz["options"] ) && $chained_quiz["options"] != "" ? $chained_quiz["options"] : "";
$options = json_decode( $options, true );

$quiz_ids = (isset($chained_quiz['quiz_ids']) && $chained_quiz['quiz_ids'] != '') ? explode(',', $chained_quiz['quiz_ids']) : array();

$chained_quizzes_print_report = (isset($options[ 'chained_quizzes_print_report' ]) && sanitize_text_field( $options[ 'chained_quizzes_print_report' ] ) == 'on') ? true : false;

$chained_quizzes_guest_access = (isset($options[ 'chained_quizzes_guest_access' ]) && sanitize_text_field( $options[ 'chained_quizzes_guest_access' ] ) == 'on') ? true : false;

// Calculate the score option
$options['calculate_report_type'] = (!isset($options['calculate_report_type'])) ? 'take_quiz' : $options['calculate_report_type'];
$calculate_report_type = (isset($options['calculate_report_type']) && $options['calculate_report_type'] != '') ? $options['calculate_report_type'] : 'take_quiz';

// Enable retake button
$options['chained_quizzes_print_enable_retake_button'] = isset($options['chained_quizzes_print_enable_retake_button']) ? sanitize_text_field($options['chained_quizzes_print_enable_retake_button']) : 'off';
$chained_quizzes_print_enable_retake_button = (isset($options['chained_quizzes_print_enable_retake_button']) && $options['chained_quizzes_print_enable_retake_button'] == 'on') ? true : false;

// Enable the Chained Quiz completion based on the pass score
$options['chained_quizzes_enable_completion_pass_score'] = isset($options['chained_quizzes_enable_completion_pass_score']) ? sanitize_text_field($options['chained_quizzes_enable_completion_pass_score']) : 'off';
$chained_quizzes_enable_completion_pass_score = (isset($options['chained_quizzes_enable_completion_pass_score']) && $options['chained_quizzes_enable_completion_pass_score'] == 'on') ? true : false;

$quizzes = $this->chained_quizzes_obj->get_quizzes();


?>

<div class="wrap">
    <div class="container-fluid">
        <h1><?php echo $heading; ?></h1>
        <hr/>
        <form class="ays-chained-quiz-form" id="ays-chained-quiz-form" method="post">
            <div class="form-group row">
                <div class="col-sm-2">
                    <label for='ays-chained-quiz-title'>
                        <?php echo __('Title', $this->plugin_name); ?>
                        <a class="ays_help" data-toggle="tooltip" title="<?php echo __('The title of chained quiz. It will show up as a placeholder for text input.',$this->plugin_name)?>">
                            <i class="ays_fa ays_fa_info_circle"></i>
                        </a>
                    </label>
                </div>
                <div class="col-sm-10">
                    <input class='ays-text-input' id='ays-chained-quiz-title' name='ays-chained-quiz-title' required type='text' value='<?php echo isset($chained_quiz['title']) ? esc_attr( $chained_quiz['title'] ) : ''; ?>'>
                </div>
            </div>

            <hr/>
            <div class="ays_chained_quiz_add_quiz_main">
                <div class="ays_quiz_action_add_chained_quiz">
                   <label><?php echo __('Add Quiz', $this->plugin_name); ?>
                        <a href="javascript:void(0)" class="ays-add-chained-quiz-select">
                            <i class="ays_fa ays_fa_plus_square" aria-hidden="true"></i>
                        </a>

                    </label>
                </div> 
                
                <div class='ays-field-dashboard ays-table-wrap'>
                    <div class="ays_quiz_chained_quiz_container">
                        <?php if($id === null): ?>
                        <div class="ays_quiz_chained_quiz_box" data-boxId="0">
                            <div class="ays_quiz_chained_quiz_box_sortable_arrow">
                                <i class="ays_fa ays_fa_arrows" aria-hidden="true"></i>
                            </div>
                            <div class="ays_quiz_chained_quiz_item" >
                                <select class="ays-chained-quizzes-select" name="ays_chained_quiz_added_quizzes[]">
                                    <option value="0">Select Quiz</option>
                                    <?php
                                  $selected = "";
                                  foreach ( $quizzes as $key => $quiz ):
                                      ?>
                                      <option value="<?php echo $quiz["id"]; ?>" <?php echo $selected; ?>><?php echo $quiz["title"]; ?></option>
                                  <?php
                                  endforeach;
                                    ?>
                                </select>
                            </div>
                           <div class="ays_quiz_chained_quiz_item_remove">
                                <a href="javascript:void(0)" class="ays-delete-chained-quiz display_none"
                                   data-id="<?php echo $key; ?>" title="<?php echo __('Delete',$this->plugin_name)?>">
                                    <i class="ays_fa ays_fa_minus_square" aria-hidden="true"></i>
                                </a>
                            </div>
                        </div>
                        <?php endif; ?>  
                        <?php
                            $quiz_ids_count = count($quiz_ids); ?>
                            <?php if($quiz_ids_count == 0 && $id !== null): ?>
                                <div class="ays_quiz_chained_quiz_box" data-boxId="0">
                                    <div class="ays_quiz_chained_quiz_box_sortable_arrow">
                                        <i class="ays_fa ays_fa_arrows" aria-hidden="true"></i>
                                    </div>
                                    <div class="ays_quiz_chained_quiz_item" >
                                        <select class="ays-chained-quizzes-select" name="ays_chained_quiz_added_quizzes[]">
                                            <option value="0">Select Quiz</option>
                                            <?php
                                          $selected = "";
                                          foreach ( $quizzes as $key => $quiz ):
                                              ?>
                                              <option value="<?php echo $quiz["id"]; ?>" <?php echo $selected; ?>><?php echo $quiz["title"]; ?></option>
                                          <?php
                                          endforeach;
                                            ?>
                                        </select>
                                    </div>
                                   <div class="ays_quiz_chained_quiz_item_remove">
                                        <a href="javascript:void(0)" class="ays-delete-chained-quiz display_none"
                                           data-id="<?php echo $key; ?>" title="<?php echo __('Delete',$this->plugin_name)?>">
                                            <i class="ays_fa ays_fa_minus_square" aria-hidden="true"></i>
                                        </a>
                                    </div>
                                </div>

                            <?php else: ?>                  
                               <?php foreach ($quiz_ids as $key => $quiz_id):
                                        $check_loop_iteration = ($quiz_ids_count > 1) ? "" : "display_none";
                                    ?>
                                        <div class="ays_quiz_chained_quiz_box" data-boxId="<?php echo $key + 1?>">
                                            <div class="ays_quiz_chained_quiz_box_sortable_arrow">
                                                <i class="ays_fa ays_fa_arrows" aria-hidden="true"></i>
                                            </div>
                                            <div class="ays_quiz_chained_quiz_item" >
                                                 <select class="ays-chained-quizzes-select" name="ays_chained_quiz_added_quizzes[]">
                                                    <option value="0"> Select Quiz </option>
                                                    <?php
                                                    $cat = 0;
                                                    foreach ($quizzes as $key => $quiz) {
                                                        $selected = (intval($quiz['id']) == intval($quiz_id)) ? "selected" : "";
                                                        if ($cat == 0 && intval($quiz_id) == 0) {
                                                            $selected = 'selected';
                                                        }
                                                        echo '<option value="' . $quiz["id"] . '" ' . $selected . '>' . stripslashes($quiz['title']) . '</option>';
                                                        $cat++;
                                                    }
                                                    ?>
                                                </select>
                                            </div>
                                            <div class="ays_quiz_chained_quiz_item_remove">
                                                <a href="javascript:void(0)" class="ays-delete-chained-quiz <?php echo $check_loop_iteration?>"
                                                   data-id="<?php echo $key; ?>" title="<?php echo __('Delete',$this->plugin_name)?>">
                                                    <i class="ays_fa ays_fa_minus_square" aria-hidden="true"></i>
                                                </a>
                                            </div>
                                        </div>
                                    <?php
                                endforeach;
                            endif;
                        ?>                        
                    </div>                   
                </div>

                <div class="ays_quiz_action_add_chained_quiz ays_quiz_action_add_chained_quiz_bottom">
                   <label><?php echo __('Add Quiz', $this->plugin_name); ?>
                        <a href="javascript:void(0)" class="ays-add-chained-quiz-select">
                            <i class="ays_fa ays_fa_plus_square" aria-hidden="true"></i>
                        </a>

                    </label>
                </div> 
                <hr>
                <div class="form-group row">
                    <div class="col-sm-2">
                        <label for="ays_chained_quizzes_report_type">
                            <?php echo __('Report Calculate Type',$this->plugin_name)?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Choose your preferred calculation type.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-3">
                        <label class="ays_quiz_loader">
                            <input type="radio" class="ays-enable-timer1" name="ays_chained_calculate_report_type" value="take_quiz" <?php echo ($calculate_report_type == 'take_quiz') ? 'checked' : '' ?>/>
                            <span style="margin-right:5px;"><?php echo __( "Take quiz", $this->plugin_name ); ?></span>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('There is no any passing score specified. The quiz taker can take quizzes after each other no matter the score he got.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                        <label class="ays_quiz_loader">
                            <input type="radio" class="ays-enable-timer1" name="ays_chained_calculate_report_type" value="pass_quiz" <?php echo ($calculate_report_type == 'pass_quiz') ? 'checked' : '' ?>/>
                            <span style="margin-right:5px;"><?php echo __( "Pass quiz", $this->plugin_name ); ?></span>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('The system will take into account the passing score set to each quiz individually from its settings(Results Settings tab). The quiz taker can take the next quiz only if he has passed the previous one successfully. ',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-7">
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="ays_chained_quizzes_enable_completion_pass_score">
                                    <span><?php echo __("Enable the Chained Quiz completion based on the pass score", $this->plugin_name); ?></span>
                                    <a class="ays_help" data-toggle="tooltip" title="<?php echo __("If you enable this option, the chained quiz will be completed in case the user doesn't get a passing score. Only in the Pass Quiz mode.", $this->plugin_name); ?>">
                                        <i class="ays_fa ays_fa_info_circle"></i>
                                    </a>
                                </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="checkbox" name="ays_chained_quizzes_enable_completion_pass_score" class="" id="ays_chained_quizzes_enable_completion_pass_score" <?php echo ($chained_quizzes_enable_completion_pass_score) ? "checked" : "";  ?>>
                            </div>
                        </div>
                    </div>
                </div> <!-- Calculate the score -->
                <hr>
                <div class="form-group row ays_toggle_parent">
                    <div class="col-sm-2">
                        <label for="ays_chained_quizzes_print_report">
                            <span><?php echo __("Print report table", $this->plugin_name); ?></span>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __("If the checkbox is ticked, then a report table will appear after passing the last quiz. It includes title, score and date of each taken quiz individually.", $this->plugin_name); ?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-3">
                        <input type="checkbox" name="ays_chained_quizzes_print_report" class="ays_toggle_checkbox" id="ays_chained_quizzes_print_report" <?php echo ($chained_quizzes_print_report) ? "checked" : "";  ?>>
                    </div>
                    <div class="col-sm-7 ays_toggle_target" style="<?php echo $chained_quizzes_print_report ? '' : 'display:none;'; ?>">
                        <div class="form-group row">
                            <div class="col-sm-4">
                                <label for="ays_chained_quizzes_print_enable_retake_button">
                                    <span><?php echo __("Enable retake button", $this->plugin_name); ?></span>
                                    <a class="ays_help" data-toggle="tooltip" title="<?php echo __("If you enable this option, you can pass the quizzes of the chain more than once. Please note, that the previous results of the quizzes will be deleted.", $this->plugin_name); ?>">
                                        <i class="ays_fa ays_fa_info_circle"></i>
                                    </a>
                                </label>
                            </div>
                            <div class="col-sm-8">
                                <input type="checkbox" name="ays_chained_quizzes_print_enable_retake_button" class="" id="ays_chained_quizzes_print_enable_retake_button" <?php echo ($chained_quizzes_print_enable_retake_button) ? "checked" : "";  ?>>
                            </div>
                        </div>
                    </div>
                </div> <!-- Print report table -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-2">
                        <label for="ays_chained_quizzes_guest_access">
                            <span><?php echo __("Allow access for guests", $this->plugin_name); ?></span>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __("Enable this option to allow the guests to pass the Chained Quiz.", $this->plugin_name); ?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-10">
                        <input type="checkbox" name="ays_chained_quizzes_guest_access" class="" id="ays_chained_quizzes_guest_access" <?php echo ($chained_quizzes_guest_access) ? "checked" : "";  ?>>
                    </div>
                </div> <!-- Allow access for guests -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-2">
                        <label>
                            <?php echo __('Chained quiz status', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Choose whether the chained quiz is active or not. If you choose Unpublished option, the chained quiz won’t be shown anywhere.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>

                    <div class="col-sm-3">
                        <div class="form-check form-check-inline">
                            <input type="radio" id="ays-publish" name="ays_chaind_quiz_publish" value="1" <?php echo ( $chained_quiz['published'] == '' ) ? "checked" : ""; ?> <?php echo ( $chained_quiz['published'] == '1') ? 'checked' : ''; ?> />
                            <label class="form-check-label" for="ays-publish"> <?php echo __('Published', $this->plugin_name); ?> </label>
                        </div>
                        <div class="form-check form-check-inline">
                            <input type="radio" id="ays-unpublish" name="ays_chaind_quiz_publish" value="0" <?php echo ( $chained_quiz['published']  == '0' ) ? 'checked' : ''; ?> />
                            <label class="form-check-label" for="ays-unpublish"> <?php echo __('Unpublished', $this->plugin_name); ?> </label>
                        </div>
                    </div>
                </div>
            </div>

            <hr/>
            <?php
            wp_nonce_field('chained_quiz_action', 'chained_quiz_action');
            $other_attributes = array( 'id' => 'ays-button' );
            submit_button( __( 'Save and close', $this->plugin_name ), 'primary', 'ays_submit', true, $other_attributes );
            if($id != null){
                submit_button(__('Save', $this->plugin_name), '', 'ays_apply', true, $other_attributes);
            }
            ?>
        </form>
    </div>
</div>
