<?php
global $ays_quiz_chained_quizzes_db_version;
$ays_quiz_chained_quizzes_db_version = '1.0.0';

/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Chained_Quizzes
 * @subpackage Quiz_Maker_Chained_Quizzes/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_Chained_Quizzes
 * @subpackage Quiz_Maker_Chained_Quizzes/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Chained_Quizzes_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {

		global $wpdb;
        global $ays_quiz_chained_quizzes_db_version;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $installed_ver = get_option( "ays_quiz_chained_quizzes_db_version" );

 		$chained_quizzes_table      = $wpdb->prefix . 'aysquiz_chainedquizzes';
        $charset_collate = $wpdb->get_charset_collate();

        if($installed_ver != $ays_quiz_chained_quizzes_db_version)  {

        	 $sql="CREATE TABLE `".$chained_quizzes_table."` (
                `id` INT(16) UNSIGNED NOT NULL AUTO_INCREMENT,
                `title` VARCHAR(256) NOT NULL,
                `quiz_ids` TEXT NOT NULL,
                `published` TINYINT UNSIGNED NOT NULL,
                `options` TEXT DEFAULT NULL,
                PRIMARY KEY (`id`)
            )$charset_collate;";

            $sql_schema = "SELECT * FROM INFORMATION_SCHEMA.TABLES
                           WHERE table_schema = '".DB_NAME."' AND table_name = '".$chained_quizzes_table."' ";
            $results = $wpdb->get_results($sql_schema);

            if(empty($results)){
                $wpdb->query( $sql );
            }else{
                dbDelta( $sql );
            }

             update_option( 'ays_quiz_chained_quizzes_db_version', $ays_quiz_chained_quizzes_db_version );

        }



	}

	public static function ays_quiz_chained_quizzes_update_db_check() {
		global $ays_quiz_chained_quizzes_db_version;
        if ( get_site_option( 'ays_quiz_chained_quizzes_db_version' ) != $ays_quiz_chained_quizzes_db_version ) {
            self::activate();
        }
	}

}
