(function( $ ) {
	'use strict';

	/**
	 * All of the code for your public-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
 	$.fn.serializeFormJSON = function () {
        var o = {},
            a = this.serializeArray();
        $.each(a, function () {
            if (o[this.name]) {
                if (!o[this.name].push) {
                    o[this.name] = [o[this.name]];
                }
                o[this.name].push(this.value || '');
            } else {
                o[this.name] = this.value || '';
            }
        });
        return o;
    };

 	$(document).ready(function () {

		$(document).on('click', '#ays_quiz_chained_quiz_button', function(e){
	        var _this = $(this);
	        var value = _this.val();

	        var _this_id = _this.attr('id');
	        var _this_chained_id = _this.attr('data-id');

	        var action = "ays_chained_quiz_retake_button";

	        var if_confirm = window.confirm(quiz_maker_chained_quiz_ajax_public.areYouSureButton);

	        if ( if_confirm ) {
		        $.ajax({
		            url: quiz_maker_chained_quiz_ajax_public.ajax_url,
		            method: 'post',
		            dataType: 'json',
		            data: {
		                id: _this_chained_id,
		                action: action
		            },
		            success: function(response){
		                if(response.status === true){
		                    window.location.reload();
		                }else{
		                	alert(response.message);
		                }
		            },
		            error: function(){
		            	alert("Something went wrong");
		            }
		        });
	        }

	    });

	    $(document).find('#ays_quiz_first_chained_quiz input.ays_next.ays_finish[name="ays_finish_quiz"]').on('click', function (e) {
	    	var _this = $(this);
	    	var parent = _this.parents('#ays_quiz_first_chained_quiz.ays_quiz_chained_quiz_container');

	    	if (parent.length > 0) {
	    		var if_cookie_exists = aysQuizGetCookie("ays_quiz_chained_quiz_information_form_data");

	            var ays_quiz_container_id = parent.find(".ays-quiz-container").attr("id");
	            var ays_quiz_container = $('#'+ays_quiz_container_id);

                var form = ays_quiz_container.find('form');
                var data = form.serializeFormJSON();

                var newData = {};
                for(var key in data) {
				    if(data.hasOwnProperty(key)) {
				        var value = data[key];

				        if(key == 'ays_user_name' || key == 'ays_user_email' || key == 'ays_user_phone'){
				        	newData[key]= data[key];
				        } else {
					        var if_data_exists = key.indexOf('quiz_attr_');
					        if( if_data_exists > -1 ){
					        	newData[key] = data[key];
					        }
				        }
				    }
				}

                if ( typeof if_cookie_exists == "undefined" || if_cookie_exists == "" ) {
            		var cookie_value = JSON.stringify(newData);
                	aysQuizCreateCookie("ays_quiz_chained_quiz_information_form_data", cookie_value, 365 );
                }
	    	}
		});

		var ifCookieExists = aysQuizGetCookie("ays_quiz_chained_quiz_information_form_data");

		if( ifCookieExists ){
			$(document).find('.ays_quiz_chained_quiz_container div.ays-quiz-container').each(function (e) {

				var cookieData = aysQuizGetCookie("ays_quiz_chained_quiz_information_form_data");
				var informationFormData = JSON.parse(cookieData);

				var ays_quiz_container = $(this);
				var ays_quiz_container_id = ays_quiz_container.attr("id");
				var form = ays_quiz_container.find('form');

				var hiddenInputHTML = "";
				for(var key in informationFormData) {
				    if(informationFormData.hasOwnProperty(key)) {
				        var value = informationFormData[key];
				        var if_current_input_exists = form.find('input[name="'+ key +'"]');
				        if( if_current_input_exists.length > 0 ){
				        	var inputType = if_current_input_exists.attr('type');
				        	if(inputType == 'checkbox'){
				        		if( value == 'on' ){
				        			if_current_input_exists.prop('checked',true);
				        			if_current_input_exists.val(value);
				        		}
				        	} else {
				        		if_current_input_exists.val(value);
				        	}
				        } else {
				        	hiddenInputHTML = $('<input type="hidden" name="'+ key +'" value="'+ value +'">');
				        	form.append(hiddenInputHTML);
				        }
				    }
				}			
			});
		}

	});


function aysQuizCreateCookie(name, value, days) {
    var expires;
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    }
    else {
        expires = "";
    }
    document.cookie = name + "=" + value + expires + "; path=/";
}

function aysQuizGetCookie(c_name) {
    if (document.cookie.length > 0) {
        var c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1) {
            c_start = c_start + c_name.length + 1;
            var c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1) {
                c_end = document.cookie.length;
            }
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}

})( jQuery );
