<?php
global $ays_quiz_ai_db_version;
$ays_quiz_ai_db_version = '1.0.0';
/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com/
 * @since      1.0.0
 *
 * @package    Quiz_Maker_ChatGPT_Question_Builder
 * @subpackage Quiz_Maker_ChatGPT_Question_Builder/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_ChatGPT_Question_Builder
 * @subpackage Quiz_Maker_ChatGPT_Question_Builder/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_AI_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		global $wpdb;
        global $ays_quiz_ai_db_version;

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

		$installed_ver = get_option( "ays_quiz_ai_db_version" );

		$quiz_settings_table = $wpdb->prefix . "aysquiz_settings";

        if($installed_ver != $ays_quiz_ai_db_version)  {

			$meta_key = "ai";
			$meta_val = "";
			$sql = "SELECT COUNT(*) FROM `".$quiz_settings_table."` WHERE `meta_key` = '".$meta_key."'";
			$result = $wpdb->get_var($sql);
			if(intval($result) == 0){
				$result = $wpdb->insert(
					$quiz_settings_table,
					array(
						'meta_key'    => $meta_key,
						'meta_value'  => $meta_val,
						'note'        => "",
						'options'     => ""
					),
					array( '%s', '%s', '%s', '%s' )
				);
			}

			update_site_option( 'ays_quiz_ai_db_version', $ays_quiz_ai_db_version );
		}
	}

	public static function ays_quiz_ai_update_db_check() {
        global $ays_quiz_ai_db_version;
        if ( get_site_option( 'ays_quiz_ai_db_version' ) != $ays_quiz_ai_db_version ) {
            self::activate();
        }
    }

}
