<?php
    $id = (isset($_GET['quiz'])) ? absint(intval($_GET['quiz'])) : null;
    $loader_iamge = "<span class='display_none ays_quiz_loader_box'><img src=". AYS_QUIZ_ADMIN_URL ."/images/loaders/loading.gif></span>";
    // Get Quiz
    if($id){
        $quiz = Quiz_Maker_Data::get_quiz_by_id($id);
    }

    // Save Conditions 
    if (isset($_POST['ays_submit']) || isset($_POST['ays_submit_top'])) {
        $_POST['id'] = $id;
        $this->quizes_obj->add_or_edit_conditions();
    }
    if (isset($_POST['ays_apply_top']) || isset($_POST['ays_apply'])) {
        $_POST["id"] = $id;
        $_POST['ays_change_type'] = 'apply';
        $this->quizes_obj->add_or_edit_conditions();
    }

    $options = array();
    if (isset( $quiz['options'] ) && $quiz['options'] != "") {
        $options = json_decode($quiz['options'], true);
    }

    $settings_options = Quiz_Maker_Settings_Actions::ays_get_setting('options');
    if($settings_options){
        $settings_options = json_decode(stripcslashes($settings_options), true);
    }else{
        $settings_options = array();
    }


    // Show all conditions results
    $options[ 'quiz_condition_show_all_results' ] = isset($options[ 'quiz_condition_show_all_results' ]) ? $options[ 'quiz_condition_show_all_results' ] : 'off';
    $quiz_condition_show_all_results = (isset($options[ 'quiz_condition_show_all_results' ]) && $options[ 'quiz_condition_show_all_results' ] == 'on') ? true : false;

    // Condition calculation type
    $quiz_condition_calculation_type = (isset($options['quiz_condition_calculation_type']) && $options['quiz_condition_calculation_type'] != '') ? sanitize_text_field( $options['quiz_condition_calculation_type'] ) : 'default';


    // Get Quiz Questions
    $question_ids_arr = isset($quiz['question_ids']) && $quiz['question_ids'] != "" ? explode("," , $quiz['question_ids']) : "";
    $questions = Quiz_Maker_Data::get_quiz_questions_by_ids($question_ids_arr);

    $conditions = array();
    $condition_html_questions = array();    
    if(!empty($questions)){
        foreach($questions as $question_key => $question_value){
            if(isset($question_value['id']) && $question_value['id'] != ""){
                $conditions['quiz']['questions'][$question_value['id']] = $question_value;
                $conditions['quiz']['questions'][$question_value['id']]['answers'] = Quiz_Maker_Data::get_answers_with_question_id($question_value['id']);
                $condition_html_questions[$question_value['id']] = $question_value;
                $condition_html_questions[$question_value['id']]['answers'] = $conditions['quiz']['questions'][$question_value['id']]['answers'];
            }
        }
    }

    $conditions['translations'] = array(
        'equalTo'     => __( 'Equal to', $this->plugin_name ),
        'notEqualTo'  => __( 'Not equal to', $this->plugin_name ),
        'greaterThan' => __( 'Greater Than', $this->plugin_name ),
        'lessThan'    => __( 'Less Than', $this->plugin_name ),
        'contains'    => __( 'Contains', $this->plugin_name ),
        'identical'   => __( 'Identical', $this->plugin_name ),
        'notContain'  => __( 'Doesn\'t contain', $this->plugin_name ),
        'and'         => __( 'And', $this->plugin_name ),
        'or'          => __( 'Or', $this->plugin_name ),
        'addFile'     => __( 'Add file', $this->plugin_name ),
        'editFile'    => __( 'Edit file', $this->plugin_name ),
        'noQuestions' => __( 'This quiz has no questions', $this->plugin_name ),
        'lessThanOrEqual'    => __( 'Less than or equal to', $this->plugin_name ),
        'greaterThanOrEqual' => __( 'Greater than or equal to', $this->plugin_name ),
        'youWantToDelete' =>__( "Are you sure you want to change? Note: All conditions will be deleted.", $this->plugin_name) ,
    );

    $conditions['removeCondition'] = '<a href="javascript:void(0)" class="ays-quiz-condition-delete-answer-small" title="'.__("Delete Question", $this->plugin_name).'">
                                            <i class="ays_fa ays_fa_minus_square" aria-hidden="true"></i>
                                        </a>';


    $keyword_default_max_value = isset($settings_options['keyword_default_max_value']) ? $settings_options['keyword_default_max_value'] : null;
    
    if($keyword_default_max_value === null){
        $keyword_default_max_value = 6;
    }
    $keyword_arr = $this->ays_quiz_generate_keyword_array( $keyword_default_max_value );

    // Enable top keywords
    $options['enable_top_keywords'] = isset($options['enable_top_keywords']) ? sanitize_text_field($options['enable_top_keywords']) : 'off';
    $enable_top_keywords = (isset($options['enable_top_keywords']) && $options['enable_top_keywords'] == 'on') ? true : false;

    $quiz_top_keywords = isset($options['assign_keywords']) && !empty($options['assign_keywords']) && $enable_top_keywords ? $options['assign_keywords'] : array();

    $conditions['keywordArr'] = array();
    foreach ($keyword_arr as $keyword) {
        $keyword_text = '';

        foreach($quiz_top_keywords as $key => $keyword_value) {
            $assign_top_keyword = isset($keyword_value['assign_top_keyword']) && $keyword_value['assign_top_keyword'] != '' ? $keyword_value['assign_top_keyword'] : '';
            $assign_top_keyword_text = isset($keyword_value['assign_top_keyword_text']) && $keyword_value['assign_top_keyword_text'] != '' ? $keyword_value['assign_top_keyword_text'] : '';

            if ($keyword == $assign_top_keyword) {
                $keyword_text = $assign_top_keyword_text;
            }
        }

        $conditions['keywordArr'][] = array(
            'keyword' => $keyword,
            'text' => $keyword_text
        );
    }

    $question_categories_arr = Quiz_Maker_Conditions_Data::ays_get_questions_categories($question_ids_arr);
    $conditions['questionCategories'] = $question_categories_arr;
    wp_localize_script($this->plugin_name, "QuizMakerCondtionData" , $conditions);

    // Get Quiz Conditions from DB
    $select_types = array(
        "radio",
        "checkbox",
        "true_or_false",
        "select"
    );

    $text_types = array(
        "text",
        "short_text",
        "date"
    );

    $number_types = array(
        "number"
    );
    $all_conditions = isset($quiz['conditions']) && $quiz['conditions'] != "" ? json_decode( $quiz['conditions'], true ) : array();
?>