<?php
global $ays_quiz_condition_results_db_version;
$ays_quiz_condition_results_db_version = '1.0.1';
/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Conditional_Logic
 * @subpackage Quiz_Maker_Conditional_Logic/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_Conditional_Logic
 * @subpackage Quiz_Maker_Conditional_Logic/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Conditional_Logic_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		global $wpdb;
		global $ays_quiz_condition_results_db_version;
		$quizes_table = $wpdb->prefix . 'aysquiz_quizes';
		// $installed_ver = get_option( "ays_quiz_condition_results_db_version" );

		// if($installed_ver != $ays_quiz_condition_results_db_version)  {
			$sql = "SELECT column_name FROM INFORMATION_SCHEMA.COLUMNS 
					WHERE TABLE_NAME = '".$quizes_table."'
					AND TABLE_SCHEMA = '".DB_NAME."'
					AND COLUMN_NAME = 'conditions'";
			
			$quiz_cat_const = $wpdb->get_row($sql, ARRAY_A);
			
			if (empty( $quiz_cat_const )) {
				$sql = "ALTER TABLE {$quizes_table}
						ADD conditions text NOT NULL DEFAULT ''";
				$wpdb->query($sql);
			}
			update_option( 'ays_quiz_condition_results_db_version', $ays_quiz_condition_results_db_version );
		// }
	}

	public static function ays_quiz_conditional_logic_update_db_check() {
        global $ays_quiz_condition_results_db_version;

		if (is_multisite()) {
			global $wpdb;
			$quizes_table = $wpdb->prefix . 'aysquiz_quizes';
			$network_id = get_current_network_id();

			$sql = "SELECT column_name 
					FROM INFORMATION_SCHEMA.COLUMNS 
					WHERE TABLE_NAME = '".$quizes_table."'
					AND TABLE_SCHEMA = '".DB_NAME."'
					AND COLUMN_NAME = 'conditions'";
			$quiz_cat_const = $wpdb->get_row($sql, ARRAY_A);

			if ( isset($quiz_cat_const) && empty($quiz_cat_const) ) {
				delete_network_option($network_id, 'ays_quiz_condition_results_db_version');
			}

			if (get_network_option($network_id, 'ays_quiz_condition_results_db_version') != $ays_quiz_condition_results_db_version) {
				self::activate();
			}
		} else {
			if (get_site_option('ays_quiz_condition_results_db_version') != $ays_quiz_condition_results_db_version) {
				self::activate();
			}
		}
	}
}
