(function ($) {
    'use strict';    
    $(document).ready(function () {

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================

        var $name_prefix       = 'ays_quiz_';
        var $html_class_prefix = '.ays-extra-shortcodes-';
        var $html_id_prefix    = '#ays-extra-shortcodes-';
        var $class_prefix      = '.ays-quiz-';

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================
        
        // for details
        $.fn.aysModal = function(action){
            var $this = $(this);
            switch(action){
                case 'hide':
                    $(this).find('.ays-modal-content').css('animation-name', 'zoomOut');
                    setTimeout(function(){
                        $(document).find('html, body').removeClass('modal-open');
                        $(document).find('.ays-modal-backdrop').remove();
                        $this.hide();
                    }, 250);
                    break;
                case 'show':
                default:
                    $this.show();
                    $(this).find('.ays-modal-content').css('animation-name', 'zoomIn');
                    $(document).find('.modal-backdrop').remove();
                    $(document.body).append('<div class="ays-modal-backdrop"></div>');
                    $(document).find('html, body').addClass('modal-open');
                    break;
            }
        }
        
        $(document).on("keydown", function(e){
            if(e.keyCode === 27){
                $(document).find('.ays-modal').aysModal('hide');
                return false;
            }
        });
        
        $(document).find('div.ays-modal').appendTo($(document.body));
        // Modal close
        $(document).find('.ays-close').on('click', function () {
            var _this = $(this);

            _this.parents('.ays-modal').aysModal('hide');
        });

        var quizUserHistoryTables = $(document).find( $class_prefix + 'user-results-container table' +  $class_prefix + 'user-score-page' );

        quizUserHistoryTables.each( function( e, i ) {
            var _this = $(this);

            _this.DataTable({
                paging: 5,
                "bDestroy": true,
                "lengthMenu": [[5, 10, 25, 50, 100, -1], [5, 10, 25, 50, 100, AysQuizHistoryObj.all]],
                "language": {
                    "sEmptyTable":     AysQuizHistoryObj.sEmptyTable,
                    "sInfo":           AysQuizHistoryObj.sInfo,
                    "sInfoEmpty":      AysQuizHistoryObj.sInfoEmpty,
                    "sInfoFiltered":   AysQuizHistoryObj.sInfoFiltered,
                    "sInfoPostFix":    "",
                    "sInfoThousands":  ",",
                    "sLengthMenu":     AysQuizHistoryObj.sLengthMenu,
                    "sLoadingRecords": AysQuizHistoryObj.sLoadingRecords,
                    "sProcessing":     AysQuizHistoryObj.sProcessing,
                    "sSearch":         AysQuizHistoryObj.sSearch,
                    "sUrl":            "",
                    "sZeroRecords":    AysQuizHistoryObj.sZeroRecords,
                    "oPaginate": {
                        "sFirst":    AysQuizHistoryObj.sFirst,
                        "sLast":     AysQuizHistoryObj.sLast,
                        "sNext":     AysQuizHistoryObj.sNext,
                        "sPrevious": AysQuizHistoryObj.sPrevious,
                    },
                    "oAria": {
                        "sSortAscending":  AysQuizHistoryObj.sSortAscending,
                        "sSortDescending": AysQuizHistoryObj.sSortDescending
                    }
                }
            });
        });
        
        // User reports info Details .Open results more information popup window
        $(document).on('click', '.ays-quiz-user-sqore-pages-details', function(e){
            e.preventDefault();

            var _this  = $(this);

            var resultsContainer = _this.parents('.ays-quiz-user-results-container');
            var uniqueID         = resultsContainer.attr('data-id');

            var parent = $(document).find('.ays-results-modal-' + uniqueID );

            parent.find('div.ays-quiz-preloader').css('display', 'flex');
            parent.aysModal('show');

            var result_id = _this.attr('data-id');
            var action = 'ays_extra_shortcode_user_reports_info_popup_ajax';
            $.ajax({
                url: AysQuizHistoryObj.ajax_url,
                method: 'post',
                dataType: 'json',
                data: {
                    result: result_id,
                    action: action,
                    unique_id: uniqueID
                },
                success: function(response){
                    if(response.status === true){
                        // $('div#ays-results-body').html(response.rows);
                        parent.find('div.ays-modal-body').html(response.rows);

                        parent.find('div.ays-quiz-preloader').css('display', 'none');
                    }else{
                        swal.fire({
                            type: 'info',
                            html: "<h2>"+ AysQuizHistoryObj.loadResource +"</h2><br><h4>"+ AysQuizHistoryObj.dataDeleted +"</h4>",
                        }).then(function(res){
                            parent.find('div.ays-quiz-preloader').css('display', 'none');
                            parent.aysModal('hide');
                        });
                    }
                },
                error: function(){
                    swal.fire({
                        type: 'info',
                        html: "<h2>"+ AysQuizHistoryObj.loadResource +"</h2><br><h4>"+ AysQuizHistoryObj.dataDeleted +"</h4>",
                    }).then(function(res){
                        parent.find('div.ays-quiz-preloader').css('display', 'none');
                        parent.aysModal('hide');
                    });
                }
            });
        });

        // Export result to pdf
        $(document).on('click','.ays-quiz-extra-shortocdes-export-pdf', function (e) {
            e.preventDefault();

            var $this  = $(this);

            var parent = $this.parents('.ays-modal');
            var uniqueID = parent.attr('data-id');

            var result_id    = $this.attr('data-result');
            var pdf_uniqueID = $this.attr('data-unique-id');
            var action       = 'ays_extra_shortcode_user_export_result_pdf';

            $this.parents('.ays-modal').find('div.ays-quiz-preloader').css('display', 'flex');
            $this.attr('disabled');

            if ( uniqueID === pdf_uniqueID ) {
                $.ajax({
                    url: AysQuizHistoryObj.ajax_url,
                    method: 'post',
                    dataType: 'json',
                    data: {
                        action: action,
                        result: result_id,
                    },
                    success: function (response) {
                        if (response.status) {
                            $this.parent().find('#downloadFileF').attr({
                                'href': response.fileUrl,
                                'download': response.fileName,
                            })[0].click();
                            window.URL.revokeObjectURL(response.fileUrl);
                        }else{
                            swal.fire({
                                type: 'info',
                                html: "<h2>"+ AysQuizHistoryObj.loadResource +"</h2><br><h4>"+ AysQuizHistoryObj.dataDeleted +"</h4>",
                            })
                        }
                        $this.parents('.ays-modal').find('div.ays-quiz-preloader').css('display', 'none');
                        $this.removeClass('disabled');
                    }
                });
            } else {
                swal.fire({
                    type: 'info',
                    html: "<h2>"+ AysQuizHistoryObj.loadResource +"</h2><br><h4>"+ AysQuizHistoryObj.dataDeleted +"</h4>",
                })
                $this.parents('.ays-modal').find('div.ays-quiz-preloader').css('display', 'none');
                $this.removeClass('disabled');
            }
            
        });

    });
    
})(jQuery);
