(function ($) {
    'use strict';    
    $(document).ready(function () {

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================

        var $name_prefix       = 'ays_quiz_';
        var $html_class_prefix = '.ays-extra-shortcodes-';
        var $html_id_prefix    = '#ays-extra-shortcodes-';

        // ===============================================================
        // ========================= Prefixes ============================
        // ===============================================================

        if (typeof google != undefined) {
            google.charts.load('current', {packages: ['corechart']});
            google.charts.setOnLoadCallback(drawBasic);
        }

        $(document).find( $html_class_prefix + 'user-progress-container' ).hover( function(e){
            var _this  = $(this);

            var circle = _this.find('svg circle');
            if (circle.length == 1) {
                circle.attr('r',5);
                circle.attr('fill-opacity',1);
            }

        }, function(e) {
            var _this  = $(this);

            var circle = _this.find('svg circle');
            if (circle.length == 1) {
                circle.attr('r',5);
                circle.attr('fill-opacity',1);
            }
        });

        function drawBasic() {

            var quizUserProgressConainter = $(document).find( $html_class_prefix + 'user-progress-container');

            quizUserProgressConainter.each( function( e, i ) {
                var _this = $(this);

                var uniqueId = _this.attr( 'data-id' );
                var mode     = _this.attr( 'data-mode' );

                var thisAysQuizPublicChartData = JSON.parse( atob( window.aysQuizPublicUserProgressData[ uniqueId ] ) );

                var divId    = $html_id_prefix + 'user-progress-chart-' + mode + '-' + uniqueId;
                var divClass = $html_class_prefix + 'user-progress-box';

                var chartDivId     = _this.find( divId );
                var chartDivIdAttr = _this.find( divClass ).attr('id');

                var modeText = mode.charAt(0).toUpperCase() + mode.slice(1);

                var viewWindow = {};
                if (mode == 'score') {
                    var viewWindow = {  
                        max: 100,
                        min: 0,
                    }
                }

                var data = new google.visualization.DataTable();
                data.addColumn('number', AysQuizPageProgressLangObj.attempt);
                data.addColumn('number', mode);
                // data.addColumn({'type': 'string', 'role': 'tooltip', 'p': {'html': true}});

                data.addRows(
                    thisAysQuizPublicChartData
                );

                var options = {
                    height: 300,
                    // tooltip: {
                    //     isHtml: true
                    // },
                    hAxis: {
                        title: AysQuizPageProgressLangObj.attempt
                    },
                    vAxis: {
                        title: modeText,
                        viewWindow,
                        // format: '0',
                    },
                    legend: {position: 'none'}
                };

                var logChart = new google.visualization.LineChart(document.getElementById( chartDivIdAttr ));
                logChart.draw(data, options);

                if (thisAysQuizPublicChartData.length == 1) {
                    setTimeout(function(){
                        var chartCircle = chartDivId.find( 'svg circl e' );
                        chartCircle.attr('r',5);
                        chartCircle.attr('fill-opacity',1);
                    },500);
                }
            });
        }
    });
    
})(jQuery);
