<?php
class Quiz_Maker_Frontend_Statistics_Data{

    //Get quiz settings by meta key
	public static function ays_get_setting( $meta_key ){
        global $wpdb;

        $settings_table  = esc_sql( $wpdb->prefix . "aysquiz_settings" );

        $sql = "SELECT meta_value FROM ".$settings_table." WHERE meta_key = '".$meta_key."'";
        $result = $wpdb->get_var($sql);

        if($result != ""){
            return $result;
        }
        return false;
    }

    //Get quiz summary by quiz id
    public static function ays_get_quiz_summary_report( $id ) {
        global $wpdb;

        $results = array();

        $quiz_report_table = $wpdb->prefix. 'aysquiz_reports';
        $quizzes_table = $wpdb->prefix. 'aysquiz_quizes';
        $answers_table = $wpdb->prefix. 'aysquiz_answers';
        $questions_table = $wpdb->prefix. 'aysquiz_questions';

        //Quiz Reports
        $get_question_ids_report_sql = "SELECT `options` FROM {$quiz_report_table} WHERE quiz_id = {$id} AND `status` = 'finished'";
        $report_results = $wpdb->get_results( $get_question_ids_report_sql, 'ARRAY_A' );

        $questions_ids = array();
        $question      = array();
        $correctness   = array();
        $user_answer   = array();
        $answerd_ans   = array();

        $total_count_quiz = '';
        foreach ($report_results as $key => $reports_result) {
            $total_count_quiz = ( isset( $reports_result['total_count'] ) && $reports_result['total_count'] != '' ) ? intval($reports_result['total_count']) : 0;
            //Options
            $report_result = ( isset( $reports_result['options'] ) && $reports_result['options'] != '' ) ? json_decode( $reports_result['options'], true ) : '';

            //Correctness
            $questions = ( isset( $report_result['correctness'] ) && !empty( $report_result['correctness'] ) ) ? $report_result['correctness'] : array();

            //User Answered
            $user_answered = ( isset( $report_result['user_answered'] ) && !empty( $report_result['user_answered'] ) ) ? $report_result['user_answered'] : array();

            //Get Question IDs
            if( !empty( $questions ) ){
                foreach ($questions as $i => $v){
                    $q = (int) substr( $i, 12 );
                    $question[] = $questions;
                    $questions_ids[] = $q;
                }
                
                $correctness[] = $questions;
            }

            //Each Questions answer
            foreach ($user_answered as $user_answered_key => $user_answered_value) {
                $user_answer[]  = $user_answered_key;
            }

            //Answered answer array
            $answerd_ans[] = $user_answered;
        }
        //Each question total answer count
        $user_answer_total_count_each_question = array_values( array_count_values( $user_answer ) );

        //Get each question correct answer count
        $question_correct_counts = array();
        foreach( $correctness as $correct_key ){
            $ays_user_counttotalanswers = array();
            
            foreach ( $correct_key as $key => $value ) {
                $result_sum = array_sum( array_column( $correctness, $key ) );
                $ays_user_counttotalanswers[$key][] = $result_sum;
            }
            
            $question_correct_counts[] = $ays_user_counttotalanswers;
        }

        //Array unique question IDs
        $quest_ids = array_values(array_unique($questions_ids));

        //Get quiz title
        $get_quiz_title = "SELECT `title`, `options` FROM {$quizzes_table} WHERE id = {$id}";
        $title_result =  $wpdb->get_row( $get_quiz_title, 'ARRAY_A' );

        //Get question answers and question information
        $get_quiz_answers = "SELECT answers.*, question.type, question.question 
                            FROM {$answers_table} AS answers 
                            RIGHT JOIN {$questions_table} AS question 
                            ON question.id = answers.question_id 
                            WHERE question_id 
                            IN(". implode( ',', $quest_ids ) .")";
        $answer_results =  $wpdb->get_results( $get_quiz_answers, 'ARRAY_A' );

        $answer                   = array();
        $q_type                   = array();
        $question                 = array();
        $correct_count            = array();
        $total                    = array();
        $answered_quest_answers   = array();

        
        //Collect all data start 
        foreach ($quest_ids as $quest_id_key => $quest_id_val) {
            $answered_quest_answers[$quest_id_val] = array_column( $answerd_ans, 'question_id_'.$quest_id_val);
        }

        foreach ( $answer_results as $key => $answer_result ) {
            $ans_id = ( isset( $answer_result['id'] ) && $answer_result['id'] != '' ) ? intval( $answer_result['id'] ) : 0;

            $q_id = ( isset( $answer_result['question_id'] ) && $answer_result['question_id'] != '' ) ? intval( $answer_result['question_id'] ) : 0;

            $quest_answers = ( isset( $answer_result['answer'] ) && $answer_result['answer'] != '' ) ? sanitize_text_field( $answer_result['answer'] ) : '';

            $quest = ( isset( $answer_result['question'] ) && $answer_result['question'] != '' ) ? sanitize_text_field( $answer_result['question'] ) : '';

            $quest_type = ( isset( $answer_result['type'] ) && $answer_result['type'] != '' ) ? sanitize_text_field( $answer_result['type'] ) : '';

            $answer[$q_id][$ans_id] = $quest_answers;
            $question[$q_id] = $quest;
            $q_type[$q_id] = $quest_type;

            foreach ($question_correct_counts as $correct_count_key => $correct_count_val) {
                $question_id = ( isset($correct_count_val['question_id_'.$q_id]) && !empty($correct_count_val['question_id_'.$q_id]) ) ? $correct_count_val['question_id_'.$q_id] : array();
                
                if(! empty( $question_id )){
                    $question_count = ( isset($question_id[0]) && $question_id[0] != '' ) ? $question_id[0] : '';
                    if($question_count != ''){
                        $correct_count[$q_id] = $question_count;
                    }
                }
            }
        }
        
        foreach ($user_answer_total_count_each_question as $total_count_each_question_key => $total_count_each_question_value) {
            $total[$quest_ids[$total_count_each_question_key]] = $total_count_each_question_value;
        }

        //Collect all data end

        //All summary data by quiz id
        foreach ( $answer as $answer_key => $answer_val ) {
            $results[$answer_key]['answers']  = $answer_val;
            $results[$answer_key]['type']     = $q_type[$answer_key];
            $results[$answer_key]['question'] = $question[$answer_key];
            $results[$answer_key]['correct']  = $correct_count[$answer_key];
            $results[$answer_key]['total']    = $total[$answer_key];
            $results[$answer_key]['answered'] = $answered_quest_answers[$answer_key];
        } 
        $result = array();

        //Quiz Reports
        $report_count_sql = "SELECT COUNT(*) FROM {$quiz_report_table} WHERE quiz_id = {$id} AND `status` = 'finished'";
        $report_count_sql_results = $wpdb->get_var( $report_count_sql );

        //Quiz options
        $quiz_opt = ( isset( $title_result['options'] ) && $title_result['options'] != '' ) ? json_decode( $title_result['options'], true ) : '';
        
        //Quiz Main Color
        $quiz_color = ( isset( $quiz_opt['color'] ) && $quiz_opt['color'] != '' ) ? sanitize_text_field( $quiz_opt['color'] ) : '';

        $result['quiz_title'] = ( isset( $title_result['title'] ) && $title_result['title'] != '' ) ? sanitize_text_field( $title_result['title'] ) : "";
        $result['quiz_total_count'] = $report_count_sql_results;
        $result['quiz_color'] = $quiz_color;
        $result['results'] = $results;
        
        return $result;
    }

    public static function ays_get_question_summary_report( $id ){
        global $wpdb;

        $results = array();
        
        $quiz_report_table = $wpdb->prefix. 'aysquiz_reports';
        $answers_table = $wpdb->prefix. 'aysquiz_answers';
        $questions_table = $wpdb->prefix. 'aysquiz_questions';

        //Quiz Reports
        $report_sql = "SELECT `options` FROM {$quiz_report_table} WHERE `status` = 'finished'";
        $report_results = $wpdb->get_results( $report_sql, 'ARRAY_A' );

        $correctness = array();
        $answered_answer = array();
        foreach ($report_results as $key => $reports_result) {
            //Options
            $report_result = ( isset( $reports_result['options'] ) && $reports_result['options'] != '' ) ? json_decode( $reports_result['options'], true ) : '';

            //Correctness
            $questions = ( isset( $report_result['correctness'] ) && !empty( $report_result['correctness'] ) ) ? $report_result['correctness'] : array();

            //User Answered
            $user_answered = ( isset( $report_result['user_answered'] ) && !empty( $report_result['user_answered'] ) ) ? $report_result['user_answered'] : array();
                    
            if( isset( $questions['question_id_'.$id] ) ){
                $correctness[] = $questions['question_id_'.$id];
            }
            
            if( isset( $user_answered['question_id_'.$id] ) && $user_answered['question_id_'.$id] != '' ){
                $answered_answer[] = $user_answered['question_id_'.$id];
            }
        }
        
        $correct_total_count = 0;
        $total_count = count($correctness);
        foreach ($correctness as $correctness_key => $correctness_value) {
            if($correctness_value === true){
                $correct_total_count++;
            }
        }

        //Get question answers and question information
        $get_quiz_questions = "SELECT answers.*, question.type, question.question 
                            FROM {$answers_table} AS answers 
                            RIGHT JOIN {$questions_table} AS question 
                            ON question.id = answers.question_id 
                            WHERE question_id = {$id} ";
        $questions_results =  $wpdb->get_results( $get_quiz_questions, 'ARRAY_A' );

        $questions_res = array();
        
        //Collect information
        foreach ($questions_results as $questions_result_key => $questions_result) {
            //Answer ID
            $answer_id = ( isset($questions_result['id']) && $questions_result['id'] != '' ) ? intval( $questions_result['id'] ) : null;

            //Question Type
            $question_type = ( isset( $questions_result['type'] ) && $questions_result['type'] != '' ) ? sanitize_text_field( $questions_result['type'] ) : '';

            //Question Name
            $question_name = ( isset( $questions_result['question'] ) && $questions_result['question'] != '' ) ? sanitize_text_field( $questions_result['question'] ) : '';

            $answer_name = ( isset( $questions_result['answer'] ) && $questions_result['answer'] != '' ) ? sanitize_text_field( $questions_result['answer'] ) : '';

            $questions_res['answers'][$answer_id] = $answer_name;
            $questions_res['question'] = $question_name;
            $questions_res['type'] = $question_type;
        }
        
        switch ($questions_res['type']) {
            case 'radio':
            case 'select':
            case 'true_or_false':
                $total_count_each_answer = array_count_values($answered_answer);
                break;
            case 'checkbox':
                $answer = array();
                foreach ($answered_answer as $user_answer_key => $user_answer_value) {
                    if( is_array( $user_answer_value ) ){
                        foreach ($user_answer_value as $user_answer_value_k => $user_answer_value_v) {
                            $answer[] = $user_answer_value_v;
                        }
                        unset($answered_answer[$user_answer_key]);
                    }
                }
                foreach ($answer as $answer_key => $answer_value) {
                    $answered_answer[] = $answer_value;
                }
                $total_count_each_answer = array_count_values($answered_answer);
                break;
            case 'text':
            case 'short_text':
            case 'number':
            case 'date':
                $total_count_each_answer = array_count_values($answered_answer);
                break;
            
            default:
                $total_count_each_answer = array_count_values($answered_answer);
                break;
        }

        $questions_res['user_answered'] = $total_count_each_answer;
        $questions_res['correct_total_count'] = $correct_total_count;
        $questions_res['total_count'] = $total_count;

        return $questions_res;
    }
}