<?php

/**
 * The public-facing functionality of the plugin.
 *
 * @link       https://ays-pro.com/
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Gamipress
 * @subpackage Quiz_Maker_Gamipress/public
 */

/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the public-facing stylesheet and JavaScript.
 *
 * @package    Quiz_Maker_Gamipress
 * @subpackage Quiz_Maker_Gamipress/public
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Gamipress_Public {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

		$this->plugin_name = $plugin_name;
		$this->version = $version;

	}

	public function ays_quiz_gamipress_finish_quiz(){
	    //GamiPress
        if(in_array('gamipress/gamipress.php', apply_filters('active_plugins', get_option('active_plugins')))){ 
            do_action( 'ays_quiz_before_save_entry' );
        }
	}

}
