<?php

/**
 * The public-facing functionality of the plugin.
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Mycred
 * @subpackage Quiz_Maker_Mycred/public
 */

/**
 * The public-facing functionality of the plugin.
 *
 * Defines the plugin name, version, and two examples hooks for how to
 * enqueue the public-facing stylesheet and JavaScript.
 *
 * @package    Quiz_Maker_Mycred
 * @subpackage Quiz_Maker_Mycred/public
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Mycred_Public {

	/**
	 * The ID of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $plugin_name    The ID of this plugin.
	 */
	private $plugin_name;

	/**
	 * The version of this plugin.
	 *
	 * @since    1.0.0
	 * @access   private
	 * @var      string    $version    The current version of this plugin.
	 */
	private $version;

	/**
	 * Initialize the class and set its properties.
	 *
	 * @since    1.0.0
	 * @param      string    $plugin_name       The name of the plugin.
	 * @param      string    $version    The version of this plugin.
	 */
	public function __construct( $plugin_name, $version ) {

		$this->plugin_name = $plugin_name;
		$this->version = $version;

	}

	public function ays_quiz_mycred_finish_quiz(){

		if (is_multisite()) {
            $isPluginActive = is_plugin_active('mycred/mycred.php');
        } else {
            $isPluginActive = in_array( 'mycred/mycred.php', apply_filters( 'active_plugins', get_option('active_plugins') ) );
        }

        if($isPluginActive){
	        do_action( 'ays_quiz_maker_mycred' );
	    }
	}

}
