<?php
    $ays_quiz_tab = 'tab1';
    if( isset($_GET['tab']) ){
        $ays_quiz_tab = sanitize_text_field( $_GET['tab'] );
    }

    $action = isset( $_GET["action"] ) ? sanitize_text_field( $_GET["action"] ) : "";

    $id = (isset($_GET["id"])) ? absint( sanitize_text_field( $_GET["id"] ) ) : null;

    $ays_prefix        = 'ays_';
    $name_prefix       = 'quiz_popup_';
    $html_name_prefix  = 'ays_quiz_popup_';
    $class_prefix      = 'ays-quiz-';

    $user_id = get_current_user_id();

    $options = array(
        // General Tab
        $name_prefix . "width" => 400,
        $name_prefix . "height" => 500,
        $name_prefix . "background_color_type" => "quiz_bg_color",
        $name_prefix . "bg_color" => "#fff",
        $name_prefix . "border_radius" => 0,
        $name_prefix . "popup_position" => "center-center",
        $name_prefix . "popup_margin" => 0,
        $name_prefix . "except_types" => "",
        $name_prefix . "except_posts" => "",
        $name_prefix . "hide_popup" => "off",
        $name_prefix . "show_on_home_page" => "on",
    );

    $object = array(
        "quiz_id" => "",
        "enable_quiz" => "on",
        "title" => "",
        "show_all" => "all",
        "status" => "published",
        'date_created' => current_time( 'mysql' ),
        'date_modified' => current_time( 'mysql' ),
        'author_id' => $user_id,
        "options" => json_encode( $options ),
    );

    $heading = "";
    switch ($action) {
        case "add":
            $heading = __( "Add new popup", $this->plugin_name );
            break;
        case "edit":
            $heading = __( "Edit popup", $this->plugin_name );
            $object = $this->popup_quiz_obj->get_item_by_id( $id );
            break;
    }


    if (isset($_POST["ays_submit"]) || isset($_POST["ays_submit_top"])) {
        $_POST["id"] = $id;
        $this->popup_quiz_obj->add_or_edit_item();
    }

    if(isset($_POST["ays_apply"]) || isset($_POST["ays_apply_top"])){
        $_POST["id"] = $id;
        $_POST["save_type"] = "apply";
        $this->popup_quiz_obj->add_or_edit_item();
    }

    if(isset($_POST["ays_save_new"]) || isset($_POST["ays_save_new_top"])){
        $_POST["id"] = $id;
        $_POST["save_type"] = "save_new";
        $this->popup_quiz_obj->add_or_edit_item();
    }

    // Get Quizzes
    $quizzes = $this->popup_quiz_obj->get_quizzes();

    $loader_iamge = '<span class="display_none ays_quiz_loader_box"><img src="' . QUIZ_MAKER_POPUP_ADMIN_URL . '/images/loaders/loading.gif"></span>';

    $args = array(
        "public" => true
    );

    $popup_quiz_all_post_types = get_post_types( $args, "objects" );

    if( array_key_exists( 'attachment', $popup_quiz_all_post_types ) ){
        unset( $popup_quiz_all_post_types['attachment'] );
    }


    // Options
    $options = isset( $object["options"] ) && $object["options"] != "" ? $object["options"] : "";
    $options = json_decode( $options, true );

    $gen_options = ($this->ays_get_setting('options') === false) ? array() : json_decode($this->ays_get_setting('options'), true);

    // Author ID
    $author_id = isset( $object['author_id'] ) && $object['author_id'] != '' ? absint( $object['author_id'] ) : $user_id;
    
    $owner = false;
    if( $user_id == $author_id ){
        $owner = true;
    }

    if( $this->current_user_can_edit ){
        $owner = true;
    }

    if( !$owner ){
        $url = esc_url_raw( remove_query_arg( array( 'action', 'quiz', 'id' ) ) );
        wp_redirect( $url );
    }

    // Enable popup quiz
    $object[ 'enable_quiz' ] = ( isset($object[ 'enable_quiz' ]) && $object[ 'enable_quiz' ] != '' ) ? stripslashes(sanitize_text_field( $object[ 'enable_quiz' ] )) : 'on';
    $enable_quiz = (isset($object[ 'enable_quiz' ]) && sanitize_text_field( $object[ 'enable_quiz' ] ) == 'on') ? true : false;

    // Title
    $title = (isset( $object["title"] ) && $object["title"] != "") ? stripslashes( esc_attr( $object["title"] ) ) : "";
    
    // Quiz_id
    $quiz_id = (isset( $object["quiz_id"] ) && $object["quiz_id"] != "") ? stripslashes( esc_attr( $object["quiz_id"] ) ) : "";
    
    // Status
    $status = (isset( $object["status"] ) && $object["status"] != "") ? stripslashes( esc_attr($object["status"]) ) : "published";

    // Date created
    $date_created = (isset( $object['date_created'] ) && $this->validateDate( $object['date_created'] )) ? $object['date_created'] : current_time( 'mysql' );
    
    // Date modified
    $date_modified = current_time( 'mysql' );

    // Show All
    $show_all = (isset( $object["show_all"] ) && $object["show_all"] != "") ? stripslashes( sanitize_text_field( $object["show_all"] ) ) : "all";
    

    // =======================  //  ======================= // ======================= // ======================= // ======================= //

    // ============================================================
    // ======================  General Tab  =======================
    // =======================    START   =========================

    // Width
    $popup_quiz_width  = (isset($options[ $name_prefix . 'width']) && $options[ $name_prefix . 'width' ] != '') ? absint( sanitize_text_field( $options[ $name_prefix . 'width' ] ) ) : 400;
   
    // Height
    $popup_quiz_height  = (isset($options[ $name_prefix . 'height']) && $options[ $name_prefix . 'height' ] != '') ? absint( sanitize_text_field( $options[ $name_prefix . 'height' ] ) ) : 500;

    // Background Color
    $popup_quiz_bg_color_type = (isset($options[ $name_prefix . 'bg_color_type']) && $options[ $name_prefix . 'bg_color_type' ] != '') ? stripslashes( sanitize_text_field( $options[ $name_prefix . 'bg_color_type' ] ) ) : 'quiz_bg_color';
    $popup_quiz_bg_color      = (isset($options[ $name_prefix . 'bg_color']) && $options[ $name_prefix . 'bg_color' ] != '') ? stripslashes( sanitize_text_field( $options[ $name_prefix . 'bg_color' ] ) ) : '#fff';
    
    // Border Radius
    $popup_quiz_border_radius  = (isset($options[ $name_prefix . 'border_radius']) && $options[ $name_prefix . 'border_radius' ] != '') ? absint( sanitize_text_field( $options[ $name_prefix . 'border_radius' ] ) ) : 0;

    // Popup Position
    $popup_quiz_position  = (isset($options[ $name_prefix . 'position']) && $options[ $name_prefix . 'position' ] != '') ? stripslashes( sanitize_text_field( $options[ $name_prefix . 'position' ] ) ) : 'center-center';

    // Popup Margin
    $popup_quiz_margin  = (isset($options[ $name_prefix . 'margin']) && $options[ $name_prefix . 'margin' ] != '') ? absint( sanitize_text_field( $options[ $name_prefix . 'margin' ] ) ) : 0;

    // Show on | Post types | Posts
    $posts = array();

    $popup_quiz_post_types  = (isset($options[ $name_prefix . 'post_types']) && ! empty( $options[ $name_prefix . 'post_types' ] ) ) ? $options[ $name_prefix . 'post_types' ] : array();

    $popup_quiz_posts  = (isset($options[ $name_prefix . 'posts']) && ! empty( $options[ $name_prefix . 'posts' ] ) ) ? $options[ $name_prefix . 'posts' ] : array();

    if ( !empty( $popup_quiz_posts ) ) {
        if( is_array( $popup_quiz_posts ) ){
            $posts = get_posts(array(
                'post_type'   => $popup_quiz_post_types,
                'numberposts' => -1
            ));
        }else{
            $posts = get_posts(array(
                "include" => array( $popup_quiz_posts )
            ));
        }
    }

    // Show on home page
    $options[ $name_prefix . 'show_on_home_page' ] = ( isset($options[ $name_prefix . 'show_on_home_page' ]) && $options[ $name_prefix . 'show_on_home_page' ] != '' ) ? stripslashes(sanitize_text_field( $options[ $name_prefix . 'show_on_home_page' ] )) : 'on';
    
    $popup_quiz_show_on_home_page = (isset($options[ $name_prefix . 'show_on_home_page' ]) && sanitize_text_field( $options[ $name_prefix . 'show_on_home_page' ] ) == 'on') ? true : false;

    // Hide Popup
    $options[ $name_prefix . 'hide_popup' ] = ( isset($options[ $name_prefix . 'hide_popup' ]) && $options[ $name_prefix . 'hide_popup' ] != '' ) ? stripslashes(sanitize_text_field( $options[ $name_prefix . 'hide_popup' ] )) : 'off';
    
    $popup_quiz_hide_popup = (isset($options[ $name_prefix . 'hide_popup' ]) && sanitize_text_field( $options[ $name_prefix . 'hide_popup' ] ) == 'on') ? true : false;

    // ============================================================
    // ======================  General Tab  =======================
    // =======================     END     ========================

    // =======================  //  ======================= // ======================= // ======================= // ======================= //