<?php
global $ays_quiz_popup_db_version;
$ays_quiz_popup_db_version = '1.0.0';

/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com/
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Popup
 * @subpackage Quiz_Maker_Popup/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_Popup
 * @subpackage Quiz_Maker_Popup/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Popup_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		global $wpdb;
        global $ays_quiz_popup_db_version;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $installed_ver = get_option( "ays_quiz_popup_db_version" );

        $popup_quizzes_table = $wpdb->prefix . QUIZ_MAKER_POPUP_DB_PREFIX . 'popup_quizzes';
        $charset_collate = $wpdb->get_charset_collate();

        if($installed_ver != $ays_quiz_popup_db_version)  {


        	$sql = "CREATE TABLE `".$popup_quizzes_table."` (
                `id` INT(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                `quiz_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
                `enable_quiz` VARCHAR(20) NOT NULL,
                `title` TEXT NOT NULL,
                `show_all` VARCHAR(20) NOT NULL,
                `status` VARCHAR(256) NOT NULL DEFAULT 'published',
                `trash_status` VARCHAR(256) NOT NULL DEFAULT '',
                `author_id` INT(11) UNSIGNED NOT NULL DEFAULT '0',
                `date_created` DATETIME NOT NULL DEFAULT '1000-01-01 00:00:00',
                `date_modified` DATETIME NOT NULL DEFAULT '1000-01-01 00:00:00',
                `options` TEXT NOT NULL DEFAULT '',
                PRIMARY KEY (`id`)
            )$charset_collate;";

            $sql_schema = "SELECT * FROM INFORMATION_SCHEMA.TABLES
                           WHERE table_schema = '".DB_NAME."' AND table_name = '".$popup_quizzes_table."' ";
            $results = $wpdb->get_results($sql_schema);

            if(empty($results)){
                $wpdb->query( $sql );
            }else{
                dbDelta( $sql );
            }

            update_option( 'ays_quiz_popup_db_version', $ays_quiz_popup_db_version );

        }
	}

	public static function ays_quiz_popup_update_db_check() {
		global $ays_quiz_popup_db_version;
        if ( get_site_option( 'ays_quiz_popup_db_version' ) != $ays_quiz_popup_db_version ) {
            self::activate();
        }
	}

}
