(function( $ ) {
	'use strict';

	/**
	 * All of the code for your admin-facing JavaScript source
	 * should reside in this file.
	 *
	 * Note: It has been assumed you will write jQuery code here, so the
	 * $ function reference has been prepared for usage within the scope
	 * of this function.
	 *
	 * This enables you to define handlers, for when the DOM is ready:
	 *
	 * $(function() {
	 *
	 * });
	 *
	 * When the window is loaded:
	 *
	 * $( window ).load(function() {
	 *
	 * });
	 *
	 * ...and/or other possibilities.
	 *
	 * Ideally, it is not considered best practise to attach more than a
	 * single DOM-ready or window-load handler for a particular page.
	 * Although scripts in the WordPress core, Plugins and Themes may be
	 * practising this, we should strive to set a better example in our own work.
	 */
	$(document).ready(function () {
		$(document).find('#ays_quiz_summary_emails_quiz_id').select2({
			minimumResultsForSearch: -1
		});

		$(document).find('#ays_quiz_summary_emails_sending_time').select2({
			minimumResultsForSearch: -1
		});

		$(document).find('#ays_quiz_summary_emails_individual_type').on('change',function(){
			var individualType = $(document).find('#ays_quiz_summary_emails_individual_type').prop('checked');
			
			if(individualType){
				$(document).find('#ays_quiz_summary_emails_quizes').show(250);
				$(document).find('.ays-quiz-individual-summary').show(250);
			}
		})

		$(document).find('#ays_quiz_summary_emails_general_type').on('change',function(){
			var generalType = $(document).find('#ays_quiz_summary_emails_general_type').prop('checked');
			
			if(generalType){
				$(document).find('#ays_quiz_summary_emails_quizes').hide(250);
				$(document).find('.ays-quiz-individual-summary').hide(250);
			}
		})

	});
})( jQuery );
