<?php

/**
 * Provide a admin area view for the plugin
 *
 * This file is used to markup the admin-facing aspects of the plugin.
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Summary_Emails
 * @subpackage Quiz_Maker_Summary_Emails/admin/partials
 */
    require_once(QUIZ_MAKER_SUMMARY_EMAILS_ADMIN_PATH . "/partials/actions/quiz-maker-summary-emails-admin-actions-options.php");
?>

<!-- This file should primarily consist of HTML with a little bit of PHP. -->
<div class="wrap">
    <div class="container-fluid">
        <form class="ays-quiz-maker-summary-emails-form" id="ays-quiz-maker-summary-emails-form" method="post">
            <h1 class="wp-heading-inline">
                <?php
                    echo $heading;
                    $other_attributes = array();
                    submit_button(__('Save and close', $this->plugin_name), 'primary', 'ays_submit_top', false, $other_attributes);
                    submit_button(__('Save', $this->plugin_name), '', 'ays_apply_top', false, $other_attributes);
                ?>
            </h1>
            <hr>
            <p class="ays-subtitle"><?php echo __('Summary options',$this->plugin_name)?></p>
            <hr/>
            <div class='quiz_summary_options'>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_title'>
                            <?php echo __('Title', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Give a title to your summary.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" class="ays-text-input" id='ays_quiz_summary_emails_title' name='ays_quiz_summary_emails_title'
                            value="<?php echo $summary_title; ?>"/>
                    </div>
                </div> <!-- Quiz summary emails title -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_status'>
                            <?php echo __('Status', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __("Specify whether the summary is On or OFF. If you choose the latter one, your summary won't be sent to the provided email addresses.",$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <label for="ays_quiz_summary_emails_status_on">On</label>
                        <input type="radio" id='ays_quiz_summary_emails_status_on' name='ays_quiz_summary_emails_status' value="on" <?php echo $summary_status == 'on' ? 'checked' : '' ; ?>/>
                        <label for="ays_quiz_summary_emails_status_off">Off</label>
                        <input type="radio" id='ays_quiz_summary_emails_status_off' name='ays_quiz_summary_emails_status' value="off" <?php echo $summary_status == 'off' ? 'checked' : ''; ?>/>
                    </div>
                </div> <!-- Quiz summary emails status -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_summary_type'>
                            <?php echo __('Summary type', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" data-html="true"
                                title="<?php
                                    echo __('Specify the type of your summary.',$this->plugin_name) .
                                    "<ul style='list-style-type: circle;padding-left: 20px;'>".
                                        "<li>". __('General – Applies to all quizzes.',$this->plugin_name) ."</li>".
                                        "<li>". __('Individual - Applies to one quiz.',$this->plugin_name) ."</li>".
                                    "</ul>";
                                ?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <label for="ays_quiz_summary_emails_general_type"><?php echo __('General', $this->plugin_name); ?></label>
                        <input type="radio" id='ays_quiz_summary_emails_general_type' name='ays_quiz_summary_emails_type' value="general" <?php echo $summary_type == 'general' ? 'checked' : ''; ?>/>
                        <label for="ays_quiz_summary_emails_individual_type">
                            <?php echo __('Individual', $this->plugin_name); ?>
                        </label>
                        <input type="radio" id='ays_quiz_summary_emails_individual_type' name='ays_quiz_summary_emails_type' value="individual" <?php echo $summary_type == 'individual' ? 'checked' : ''; ?>/>
                    </div>
                </div> <!-- Quiz summary emails type -->
                <hr class="ays-quiz-individual-summary" style="<?php echo $summary_type == 'individual' ? 'display:block' : 'display:none' ;?>">
                <div class="form-group row" id="ays_quiz_summary_emails_quizes" style="<?php echo $summary_type == 'individual' ? 'display:flex' : 'display:none';?>">
                
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_quiz_id'>
                            <?php echo __('Choose the quiz', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Select the quiz about which you would like to receive the summary. It works with an Individual type of summary.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <select name="ays_quiz_summary_emails_quiz_id" id="ays_quiz_summary_emails_quiz_id">
                            <?php   
                                foreach($quiz_titles as $key => $quiz_title):
                                    $selected = '';
                                    if(is_array($quiz_title)){
                                        if(in_array($summary_quiz_id,$quiz_title)){
                                            $selected = 'selected';
                                        }else{
                                            $selected = '';
                                        }
                                    }else{
                                        if($summary_quiz_id == $quiz_title['id']){
                                            $selected = 'selected';
                                        }else{
                                            $selected = '';
                                        }
                                    }
                            ?>
                                <option value="<?php echo $quiz_title['id']; ?>" <?php echo $selected; ?>>
                                    <?php echo $quiz_title['title']; ?>
                                </option>
                            <?php
                            endforeach
                            ?>
                        </select>
                    </div>
                </div><!-- Quiz summary quizes -->
                <hr>
                <div class="form-group row" >
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_sending_time'>
                            <?php echo __('Session period', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Decide how often the provided email addresses should receive the summary.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <select name="ays_quiz_summary_emails_sending_time" id="ays_quiz_summary_emails_sending_time">
                            <?php   
                                foreach($sending_time_array as $key => $sending_time){
                                    $selected = '';
                                    if(is_array($sending_time)){
                                        if(in_array($summary_sending_time,$sending_time)){
                                            $selected = 'selected';
                                        }else{
                                            $selected = '';
                                        }
                                    }else{
                                        if($summary_sending_time == $key){
                                            $selected = 'selected';
                                        }else{
                                            $selected = '';
                                        }
                                    }
                                
                            ?>
                                <option value="<?php echo $key; ?>" <?php echo $selected; ?>>
                                    <?php echo $sending_time; ?>
                                </option>
                            <?php
                            }
                            ?>
                        </select>
                    </div>
                </div><!-- Quiz summary time -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_email'>
                            <?php echo __('Email addresses', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Enter the email address(es) of those admins, who are going to receive the summary.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <input type="text" class="ays-text-input" id='ays_quiz_summary_emails_email' name='ays_quiz_summary_emails_email[]' value="<?php echo $summary_sending_emails; ?>" multiple placeholder='Admins Emails'/>
                    </div>
                </div> <!-- Quiz summary emails -->
                <hr>
                <div class="form-group row">
                    <div class="col-sm-4">
                        <label for='ays_quiz_summary_emails_email_to_users'>
                            <?php echo __('Send report to users ', $this->plugin_name); ?>
                            <a class="ays_help" data-toggle="tooltip" title="<?php echo __('Tick the option if you want to send summary reports to the quiz takers as well.',$this->plugin_name)?>">
                                <i class="ays_fa ays_fa_info_circle"></i>
                            </a>
                        </label>
                    </div>
                    <div class="col-sm-8">
                        <input type="checkbox" id='ays_quiz_summary_emails_email_to_users' name='ays_quiz_summary_emails_email_to_users' value="on" <?php echo $summary_emails_report_to_users ? 'checked' : '';?>/>
                    </div>
                </div> <!-- Send Quiz summary email to the users -->
            </div>
            <hr>
            <?php
                    wp_nonce_field('quiz-maker-summary-emails_action', 'quiz-maker-summary-emails_action');
                    $other_attributes = array();
                    $buttons_html = '';
                    $buttons_html .= '<div class="ays_save_buttons_content">';
                        $buttons_html .= '<div class="ays_save_buttons_box">';
                        echo $buttons_html;
                            submit_button(__('Save and close', $this->plugin_name), 'primary', 'ays_submit', true, $other_attributes);
                            submit_button(__('Save', $this->plugin_name), '', 'ays_apply', true, $other_attributes);
                        $buttons_html .= '</div>';
                    $buttons_html .= '</div>';
                    echo $buttons_html;
            ?>
        </form>
    </div>
</div>