<?php
global $ays_quiz_summary_emails_db_version;
$ays_quiz_summary_emails_db_version = '1.0.1';
/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Summary_Emails
 * @subpackage Quiz_Maker_Summary_Emails/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_Summary_Emails
 * @subpackage Quiz_Maker_Summary_Emails/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Summary_Emails_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
		global $wpdb; 
        global $ays_quiz_summary_emails_db_version;
		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

		$installed_ver = get_option( "ays_quiz_summary_emails_db_version" );
		$quiz_summary_emails      =   $wpdb->prefix . 'aysquiz_summary_emails';
		$charset_collate = $wpdb->get_charset_collate();

		if($installed_ver != $ays_quiz_summary_emails_db_version)  {
            $sql="CREATE TABLE `".$quiz_summary_emails."` (
                `id` INT(16) UNSIGNED NOT NULL AUTO_INCREMENT,
                `title` VARCHAR(256) DEFAULT NULL,
                `type` TEXT  DEFAULT NULL,
                `quiz_id` INT(16) UNSIGNED DEFAULT NULL,
                `sending_time` TEXT  DEFAULT NULL,
                `emails` TEXT  DEFAULT NULL,
                `status` TEXT  DEFAULT NULL,
                `options` TEXT DEFAULT NULL,
                PRIMARY KEY (`id`)
            )$charset_collate;";
            dbDelta( $sql );

            $sql = "SELECT * FROM INFORMATION_SCHEMA.STATISTICS 
                    WHERE TABLE_NAME = '".$quiz_summary_emails."'
                    AND INDEX_NAME = 'FK_summary_emails' 
                    AND INDEX_SCHEMA = '".DB_NAME."';";
            
            $quiz_cat_const = $wpdb->get_row($sql, ARRAY_A);

            if (! empty( $quiz_cat_const )) {
                $sql = "ALTER TABLE `{$quiz_summary_emails}`
                        DROP INDEX `FK_summary_emails`";
                $wpdb->query($sql);
			}
			
            update_option( 'ays_quiz_summary_emails_db_version', $ays_quiz_summary_emails_db_version );
            
        }
	}

	public static function ays_quiz_update_db_check() {
		global $ays_quiz_summary_emails_db_version;
        if ( get_site_option( 'ays_quiz_summary_emails_db_version' ) != $ays_quiz_summary_emails_db_version ) {
            self::activate();
        }
    }

}
