<?php
global $ays_quiz_woocommerce_db_version;
$ays_quiz_woocommerce_db_version = '1.0.0';

/**
 * Fired during plugin activation
 *
 * @link       https://ays-pro.com
 * @since      1.0.0
 *
 * @package    Quiz_Maker_Woocommerce
 * @subpackage Quiz_Maker_Woocommerce/includes
 */

/**
 * Fired during plugin activation.
 *
 * This class defines all code necessary to run during the plugin's activation.
 *
 * @since      1.0.0
 * @package    Quiz_Maker_Woocommerce
 * @subpackage Quiz_Maker_Woocommerce/includes
 * @author     Quiz Maker team <info@ays-pro.com>
 */
class Quiz_Maker_Woocommerce_Activator {

	/**
	 * Short Description. (use period)
	 *
	 * Long Description.
	 *
	 * @since    1.0.0
	 */
	public static function activate() {
        global $wpdb;
        global $ays_quiz_woocommerce_db_version;
        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        $installed_ver = get_option( "ays_quiz_woocommerce_db_version" );

        $quizzes_table = $wpdb->prefix . QUIZ_MAKER_WOOCOMMERCE_DB_PREFIX . 'quizes';
        $charset_collate = $wpdb->get_charset_collate();

        if($installed_ver != $ays_quiz_woocommerce_db_version)  {

            $sql = "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS
                    WHERE table_name = '{$quizzes_table}' AND column_name = 'product_id'";

            $row = $wpdb->get_results( $sql );

            if( empty($row) ){
                $sql = "ALTER TABLE {$quizzes_table} ADD product_id VARCHAR(256) NOT NULL DEFAULT ''";

                $wpdb->query( $sql );
            }

            update_option( 'ays_quiz_woocommerce_db_version', $ays_quiz_woocommerce_db_version );

        }

    }

    public static function ays_quiz_woocommerce_update_db_check() {
        global $ays_quiz_woocommerce_db_version;
        if ( get_site_option( 'ays_quiz_woocommerce_db_version' ) != $ays_quiz_woocommerce_db_version ) {
            self::activate();
        }
    }
}
